.TH gmanpage 1 "Version 1.2.3, Friday 26th April 2013" "David M. Balean"
.SH NAME
gmanpage \- Gtk manpage reader/editor
.SH SYNOPSIS
\fBgmanpage\fP [\fINAME\fP]
.SH "DESCRIPTION"
The programme starts by loading  front end main window which the user
sees. This is divided into three areas, a menu, string search entry,
and a row of buttons. If \fINAME\fP is specified then it is assumed to be
either manual page or the pathname of a file and an attempt is made to
display it.
.br
.SS
\fIMain Window\fP
.SS
\fBTHE FIRST ROW\fP
.br
is the menu bar. The menu consists of \fIFile\fP, \fIOptions\fP,
\fISections\fP and \fIHelp\fP.
.sp
\fBFile\fP
.br
The \fIFile\fP menu consists of \fIOpen for view\fP, \fINew edit\fP,
\fILoad for edit\fP, and \fIQuit\fP.
.sp
\fBOptions\fP
.br
The \fIOptions\fP are either \fIWindow Sizes\fP, \fIPrinter Prefences\fP
and  \fIEditor Preferences\fP.
Using \fIWindow Sizes\fP the window sizes can be changed.
Using \fIPrinter Prefences\fP the printer, page size and font can be changed.
With \fIEditor Preferences\fP the autosave facility can be customised. Note that
the user can select to autosave after so many changes to the document or
after so many seconds or both in which case the first to occur will trigger
the autosave.
.sp
\fBSections\fP
.br
The \fISections\fP menu gives the user
the opportunity to display a list of manual pages in a chosen section and then
a man page can be selected from that list.
.sp
\fBHelp\fP
.br
The \fIHelp\fP menu gives the user the chance
to select \fIAbout\fP or \fIHelp\fP. \fIAbout\fP displays a short notice about
this version of \fBgmanpage\fP.  \fIHelp\fP displays the \fBgmanpage\fP
manual page (this document).
.SS
\fBTHE SECOND ROW\fP
.br
contains the string search entry widget where the user can
enter a string.  This is the name that will be searched for.  If the user
enters a \fB[RETURN]\fP (usually the  \fBENTER\fP key), the search for that
manual page will be immediate.
.SS
\fBTHE LAST ROW\fP
.br
consists of three buttons, \fB[Manual Page]\fP, \fB[Apropos]\fP and
\fB[QUIT]\fP. 
.br
\fBManual Page\fP starts a search for the manual page that
corresponds to the specified search string in the second row.  This will be
displayed if it is found.  If not, the user will be informed that it wasn't
found. 
.br
\fBApropos\fP starts a search of all the manual page headers that
contain the search string in the second row and this list is displayed.
The user can then select the appropriate manual page by clicking the left
mouse button on it's entry in the displaythe specified search stringed list. 
.br
\fBQUIT\fP causes \fBgmanpage\fP to quit.  All open windows are shut
down as well.
.br
.SS
\fICHOOSE MANPAGE Window\fP
If the user chooses a section to display from the \fBSection\fP menu, this is
the window that is displayed.  It contains a list of all the manual pages
appropriate for that section and where they are to be found.  The user can
click on an entry to cause that manual page to be displayed.  At the base there
is a \fBClose\fP button which closes this window but leaves the main program
still running.
.br
.SS
\fIManual Page Window\fP
In addition to the display of the manual page there is a row at the
base of the window which gives the user some extra options.  Many users
are not aware that manual pages often contain comments.  These are are
all collected by gmanpage and placed at the start if  \fIComments\fP is
selected to display them.  It isn't very helpful usually.  The manpage
can be reloaded with the  \fIReload\fP button and  searched for a search
string with the  \fISearch\fP  button. \fIEdit\fP opens a window with the source
file loaded for edit. The \fIPrint\fP button will automatically send a copy
to the printer chosen in \fIPrinter Prefences\fP if there is one.  Finally,
the user can choose \fBClose\fP which closes this window but the main program
is left running.
.br
.SS
\fIApropos Window\fP
If the user left-clicks on the \fBApropos\fP button, this window displays the
\fBapropos\fP(1) information, if any, concerning the the specified search string.
This assumes that the \fBwhatis\fP(1) database is up to date.
The \fBwhatis\fP(1) database is created by the command:-
.br
"\fI/usr/sbin/makewhatis -w\fP".
.br
and updated using:-
.br
"\fI/usr/sbin/makewhatis -u -w\fP".
.br
The user can "left click" on an item to display that manual page.
There is a \fBClose\fP button which, as for a manual page, closes
this window but leaves the main program still running.
.br
.SS
\fIEdit Window\fP
The edit window has a menu bar, a tool bar, and the edit area.
The menu bar consists of \fIFile\fP, \fIEdit\fP and \fISearch\fP.
.sp
\fBFile\fP consists of  \fIOpen New\fP, \fILoad\fP, \fISave\fP, \fISave As\fP,
\fIManpage preview\fP, \fIQuit\fP  and, after a separator, \fIClear\fP.
The \fIManpage preview\fP menu item will be unavailable if the file
has not yet been saved. The preview is kept up to date as the user
writes to the file.
.sp
\fBEdit\fP consists of   \fIUndo\fP, \fIRedo\fP, separator, \fICopy\fP, \fICut\fP, \fIDelete\fP,  \fIPaste\fP and,
after another separator, \fISelect All\fP.
.sp
\fBSearch\fP consists of  \fIFind\fP,  \fIReplace\fP and  \fIFind/Replace Next\fP.
.SH "FILES"
If installed using the \fB.rpm\fP, the default pathnames are as follows:-

\fI/usr/bin/gmanpage\fP This is the executable file.
.sp
\fI/usr/share/man/man1/gmanpage.1.gz\fP The manual page (this document).
.br
\fI/usr/share/gmanpage/AUTHORS\fP
.br
\fI/usr/share/gmanpage/README\fP
.br
\fI/usr/share/gmanpage/COPYING\fP
.br
\fI/usr/share/gmanpage/ChangeLog\fP
.br
\fI/usr/share/gmanpage/NEWS\fP
.br
\fI/usr/share/gmanpage/TODO\fP
.sp
\fI/usr/share/gmanpage/doc/images/gmanpage.png\fP Images.
.br
\fI/usr/share/gmanpage/doc/images/gmanpage.xpm\fP
.br
\fI/usr/share/gmanpage/doc/images/gmanpage_apropos_window.png\fP
.br
\fI/usr/share/gmanpage/doc/gmanpage_edit_window.png\fP
.br
.I
/usr/share/gmanpage/doc/images/gmanpage_editor_preferences_window.png
.br
.I
/usr/share/gmanpage/doc/images/gmanpage_main_window.png
.br
.I
/usr/share/gmanpage/doc/images/gmanpage_main_window_file_menu.png
.br
.I
/usr/share/gmanpage/doc/images/gmanpage_manpage_window.png
.br
.I
/usr/share/gmanpage/doc/images/gmanpage_printerprefences_window.png
.br
.I
/usr/share/gmanpage/doc/images/gmanpage_section_window.png
.br
.I
/usr/share/gmanpage/doc/images/gmanpage_windowsizes_window.png
.sp
.I
/usr/share/gmanpage/doc/gmanpage.html\fP HTML documentation.
.sp
.I
/usr/share/pixmaps/gmanpage/gmanpage.png\fP Pixmaps.
.br
.I
/usr/share/pixmaps/gmanpage/gmanpage.xpm
.br
.I
/usr/share/pixmaps/gmanpage/gmanpage.svg
.br
.I
/usr/share/pixmaps/gmanpage/gmanpage.svgz
.sp
Right-clicking on an uninhabited part of the Gnome panel enables one to add
a custom widget to the panel. One of these pixmap files can be used if the user
wants to use them for "\fBgmanpage\fP"'s  icon on the panel.
Right-clicking on "Applications" in the top panel enables the menu to
be edited if it the user wants to add  "\fBgmanpage\fP to the menu.
.SS " "
.SH "BUGS"
Probably completely covered in them so make sure the
insecticide is handy.  Use at your own risk.
.SH "NOTE"
Many years ago, about Redhat version 4.2 or 5.1, \fBxman\fP was a favourite
viewer for manual pages and had a very small footprint on the desktop.
Unfortunately it became progressively more useless with later versions
because of changes in the way the pages were processed. The Sun Ultra-5 (Sparc)
with Debian Etch can use both \fBxman\fP and \fBgmanpage\fP.
This problem with Redhat and Fedora resulted in the beginnings of this program.
At first it was called \fBgman\fP but later changed to \fBgmanpage\fP and
coded in "C++" instead of "C". The primitive editor is a later extra tacked on for fun. 
.SH "AUTHOR & COPYRIGHT"
.SS ""
gmanpage version 1.2.2
.sp
Copyright (C) 2013 David M. Balean <linprogs@balean.net>
.sp
This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License or,
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

.SH "SEE ALSO"
apropos(1), man(1), whatis(1)