# gmanpage.spec

%define name		gmanpage
%define version		1.2.3

# ---------------------------------------------------

# Use the following for a standard install
# Prefix:		/usr/local
# %define datadir	%{prefix}/share
# %define mandir	%{prefix}/man

# Use the following for a Redhat/Fedora install
Prefix:			/
%define datadir		%{prefix}/usr/share
%define mandir		%{prefix}/usr/share/man

# derived from above but they work as fine tuning...
# Needed for ./configure which is part of autogen.sh
# Alter as required

%define bindir		%{prefix}/usr/bin
%define sysconfdir	%{prefix}/etc
%define localstatedir	%{prefix}/var


# derived from above but for this .spec file only
# DO NOT CHANGE THESE UNLESS YOU KNOW WHAT YOU'RE DOING!
%define doc		%{datadir}/%{name}
%define docdir		%{datadir}/%{name}/doc

%define pixmaps %{datadir}/pixmaps
%define pixmapsdir %{datadir}/pixmaps/%{name}

%define appdir    %{datadir}/applications

%define logdir		%{localstatedir}/log
%define rundir		%{localstatedir}/run

%define sname	%{name}-%{version}
%define sdir	$RPM_BUILD_DIR/%{name}-%{version}

Name:       %{name}
Version:    %{version}
Release:    1%{?dist}
Summary:    Gtk manpage reader/editor.

Group:      Applications/System   
License:    GPL
Packager:   David M. Balean  <linprogs@balean.net>
Vendor:		  David M. Balean  <linprogs@balean.net>
URL:		    http://www.balean.net
Requires: 	glib >= 2.10
Requires: 	gtk3 >= 3.6.4
Requires:	  /bin/sh
BuildRoot:  %{_tmppath}/%{sname}
Source:		  %{sname}.tar.gz

%description
Read and/or edit manpages.


%prep
%setup -q


%build
rm -rf $RPM_BUILD_ROOT

rm -f %{sdir}/Makefile %{sdir}/Makefile.in configure autote.cache

rm -f %{sdir}/src/Makefile %{sdir}/src/Makefile.in
rm -rf %{sdir}/src/.deps


%{sdir}/autogen.sh  --prefix=%{prefix} \
	--bindir=%{bindir} --datadir=%{datadir} \
	--sysconfdir=%{sysconfdir} \
	--localstatedir=%{localstatedir} \
	--mandir=%{mandir}

make


%install

make prefix=$RPM_BUILD_ROOT%{prefix} \
	bindir=$RPM_BUILD_ROOT%{bindir} \
	datadir=$RPM_BUILD_ROOT%{datadir} \
	sysconfdir=$RPM_BUILD_ROOT%{sysconfdir} \
	localstatedir=$RPM_BUILD_ROOT%{localstatedir} \
	mandir=$RPM_BUILD_ROOT%{mandir} install

gzip --best $RPM_BUILD_ROOT%{mandir}/man1/gmanpage.1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)

%dir %{doc}
%dir %{docdir}
%dir %{pixmaps}
%dir %{pixmapsdir}
%dir %{mandir}
%dir %{mandir}/man1


# Looks like this has to be it...
%{doc}/AUTHORS
%{doc}/ChangeLog
%{doc}/COPYING
%{doc}/NEWS
%{doc}/README
%{doc}/TODO

%{docdir}/gmanpage.html
%{docdir}/images/gmanpage.png
%{docdir}/images/gmanpage.xpm
%{docdir}/images/gmanpage_apropos_window.png
%{docdir}/images/gmanpage_edit_window.png
%{docdir}/images/gmanpage_editor_preferences_window.png
%{docdir}/images/gmanpage_main_window.png
%{docdir}/images/gmanpage_main_window_file_menu.png
%{docdir}/images/gmanpage_manpage_window.png
%{docdir}/images/gmanpage_printer_preferences_window.png
%{docdir}/images/gmanpage_section_window.png
%{docdir}/images/gmanpage_windowsizes_window.png

%{mandir}/man1/gmanpage.1.gz

%{pixmapsdir}/gmanpage.png
%{pixmapsdir}/gmanpage.xpm
%{pixmapsdir}/gmanpage.svg
%{pixmapsdir}/gmanpage.svgz
%{appdir}/gmanpage.desktop

%defattr(0711,root,root,-)
%{bindir}/gmanpage



# %changelog
