/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       about.cpp                                                 *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       25-Mar-2013 11.25.26 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* About this program and load help (.html) information                      *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#include "about.h"
#include "misc.h"
#include "gman.h"
#include "RH_version.h"

About::~About(void)
{
   cout << "~About:\n";
   if (pixbuf) g_object_unref(G_OBJECT(pixbuf));
}

About::About(GMan *g, char *title)
{	
cout << "About:\n";
gman = g;
create_display(title);
}

void About::close_dialog (GtkWidget *widget, About *about)
{
 about->gman->delete_about(about);
}

void About::quit_about(GtkWidget *widget, About *about)
{
      gtk_widget_destroy ( GTK_WIDGET(about->window) );
      about->window = NULL;	
}

void About::create_display(char *title)
{
  using namespace misc;
 
  GtkWidget *scrolled_window;
  GtkWidget *label;
  GtkWidget *box, *vbox;
  GtkWidget *button;
 
  string message = RH_VERSION_STRING;
  message += "\n";
  message +=  RH_PROJECT_CONTACT;
  message +=   "\n\n";

  message +=  RH_PROJECT_COPYRIGHT;
  message += "\n\n";

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_show (window);
  g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (close_dialog),
		    this);

  gtk_window_set_title (GTK_WINDOW (window), title);
  gtk_widget_set_size_request (window,
			       gman->prefs.get_about_width(),
			       gman->prefs.get_about_height());


  gtk_container_set_border_width(GTK_CONTAINER(window), 2);
	
  pixbuf = gtk_widget_render_icon_pixbuf(GTK_WIDGET(window),
				  GTK_STOCK_ABOUT,
				  GTK_ICON_SIZE_DIALOG);
	
  if (pixbuf) gtk_window_set_icon( GTK_WINDOW(window), pixbuf);

	vbox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 10);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (window), vbox);
	
  scrolled_window = gtk_scrolled_window_new(NULL, NULL);

    /* the policy is one of GTK_POLICY AUTOMATIC, or GTK_POLICY_ALWAYS.
     * GTK_POLICY_AUTOMATIC will automatically decide whether you need
     * scrollbars, whereas GTK_POLICY_ALWAYS will always leave the scrollbars
     * there.  The first one is the horizontal scrollbar, the second, 
     * the vertical. */
  gtk_scrolled_window_set_policy ( GTK_SCROLLED_WINDOW(scrolled_window),
                                GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS );

  gtk_widget_show (scrolled_window);
  gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, TRUE, TRUE, 0);


	box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 0);

  gtk_widget_show (box);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_window),
					box);
  
  label = gtk_label_new(message.c_str());
  gtk_widget_show (label);
  gtk_container_add(GTK_CONTAINER(box),label);
  

	box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 2);

	
  gtk_widget_show (box);

  gtk_box_pack_end (GTK_BOX(vbox), box, FALSE, FALSE, 0);

  // --- Create the "Close" button
  button = gtk_button_new_with_label ("Close");

  // --- Need to close the window if they press "Close"
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK ( quit_about ),  this);

  // --- Allow it to be the default button
  gtk_widget_set_can_default(GTK_WIDGET(button), TRUE);  // GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);

  // --- Add the button to the dialog
  gtk_box_pack_start (GTK_BOX(box), 
		      button, TRUE, TRUE, 0);
	

  // --- Make the button the default button
  gtk_widget_grab_default (button);

  // --- Make the button visible
  gtk_widget_show (button);

}
