/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       apropos.h                                                 *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       21-Mar-2009 12.06.29 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __APROPOS_H__
#define __APROPOS_H__

#include <list>
#include <string>
#include <gtk/gtk.h>

#include "gman.h"

using namespace std;

class Apropos
{
 public:
  Apropos(class GMan *g);
  ~Apropos(void);

  static void close_dialog (GtkWidget *widget, Apropos *ap);
  static void item_selected(GtkWidget *widget, Apropos *ap);
  
  gboolean search(char *manpage);
  void apropos(char *string);  
  gboolean find_in_section(char *mpage, char *s_num );

  
 private:
  static void callback_list_select(GtkWidget *widget, Apropos *ap);
  void display_manpage(char *buffer, Apropos *ap);
  
  void create_list(char *buffer);
  void add_list_to_view(void);
  void create_display(char *str);
  GtkWidget *create_view(void);

  GtkWidget *window;
  GtkWidget *view;
  
  static GMan *gman;

  GdkPixbuf *pixbuf;
  
  list<string>  ap_list;

 protected:

};


#endif // _APROPOS_H
