/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       complain.h                                                *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       21-Mar-2009 12.06.38 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __COMPLAIN_H__
#define __COMPLAIN_H__

#include <gtk/gtk.h>


class Complain
{
 public:
  Complain(void);
  ~Complain(void);


  void complain (int n, char *title, char *msg, 
			 void (*YesFunc)(GtkWidget *widget, Complain *c), 
		 void (*NoFunc)(GtkWidget *widget, Complain *c),
		 gpointer d );

  static void end_complain(GtkWidget *widget, Complain *c);
  static void clear_complain(GtkWidget *widget, Complain *c);

  static void left_button(GtkWidget *widget, Complain *c);

  static const int CN_ABORT        = 0;
  static const int CN_CONTINUE     = 1;
  static const int CN_OK           = 2;
  static const int CN_CANCEL       = 3;
  static const int CN_OK_CANCEL    = 4;
  static const int CN_OK_ABORT     = 5;
  static const int CN_RETRY_ABORT  = 6;
  static const int CN_RETRY_CANCEL = 7;
  static const int CN_YES_NO       = 8;

  gpointer data;

 private:
  GtkWidget *dialog_window;

  GdkPixbuf *pixbuf;


 protected:

};

#endif // _COMPLAIN_H
