/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       editprefs.h                                               *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       29-Mar-2013 12.46.05 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __EDITPREFS_H__
#define __EDITPREFS_H__

#include <gtk/gtk.h>

#include "gman.h"
#include "edit.h"

class EditPrefs
{
public:
  EditPrefs(class GMan *g);
  ~EditPrefs(void);

  static void callback_close_dialog (GtkWidget *widget, EditPrefs *ep);
  static void callback_cancel_editprefs(GtkWidget *widget, EditPrefs *ep);
  static void callback_do_use(GtkWidget *widget, EditPrefs *ep);
  static void callback_do_save(GtkWidget *widget, EditPrefs *ep);
  static void autosave_check_button_clicked(GtkWidget *widget, EditPrefs *ep);

  void get_user_data(EditPrefs *ep);
  class GMan *gman;
  GtkWidget *window;
  GtkWidget *autosave_check_button;
  GtkWidget *seconds_check_button;
  GtkWidget *changes_check_button;
  GtkWidget *seconds_spinner;
  GtkWidget *changes_spinner;

private:
  static void seconds_check_button_clicked(GtkWidget *widget, EditPrefs *ep);
  static void changes_check_button_clicked(GtkWidget *widget, EditPrefs *ep);
	
	void restart_autosave_timers(EditPrefs *ep);

  void create_display(void);
  
  GdkPixbuf *pixbuf;

protected:

};


#endif // __EDITPREFS_H__
