/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       gman.cpp                                                  *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       26-Apr-2013 22.38.38 -36000 0                             *
*                                                                           *
*File Summary:                                                              *
* The initial main window                                                   *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#include <iostream>
#include <unistd.h>

#include "printprefs.h"
#include "gman.h"

using namespace std;
using namespace misc;

guint GMan::expose_signal = 0;
char *GMan::start_manpage = NULL;
GList *GMan::apropos = NULL;
GList *GMan::manpath = NULL;
GList *GMan::manpages = NULL;
GList *GMan::edits = NULL;
GdkPixbuf *GMan::icon_pixbuf = NULL;
list<string> GMan::section_num_list;
Printprefs *GMan::printprefs = NULL;
Prefs GMan::prefs;

/***
    Data generated using command:-
gdk-pixbuf-csource --extern gmanpage.png > gmanpage_image.cpp
    then copied here and modified as required
***/


/* GdkPixbuf RGBA C-Source image dump 1-byte-run-length-encoded */

#ifdef __SUNPRO_C
#pragma align 4 (GMan::icon_pixbuf_source)
#endif
#ifdef __GNUC__
const guint8 GMan::icon_pixbuf_source[] __attribute__ ((__aligned__ (4))) = 
#else
const guint8 GMan::icon_pixbuf_source[] = 
#endif
{ ""
  /* Pixbuf magic (0x47646b50) */
  "GdkP"
  /* length: header (24) + pixel_data (2170) */
  "\0\0\10\222"
  /* pixdata_type (0x2010002) */
  "\2\1\0\2"
  /* rowstride (256) */
  "\0\0\1\0"
  /* width (64) */
  "\0\0\0@"
  /* height (64) */
  "\0\0\0@"
  /* pixel_data: */
  "\220\377\377\377\0\237\377\377\377\377\236\377\377\377\0\245\377\377"
  "\377\377\231\377\377\377\0\251\377\377\377\377\226\377\377\377\0\210"
  "\377\377\377\377\234\377\0\0\377\210\377\377\377\377\223\377\377\377"
  "\0\207\377\377\377\377\240\377\0\0\377\207\377\377\377\377\221\377\377"
  "\377\0\206\377\377\377\377\244\377\0\0\377\206\377\377\377\377\217\377"
  "\377\377\0\206\377\377\377\377\246\377\0\0\377\206\377\377\377\377\215"
  "\377\377\377\0\205\377\377\377\377\211\377\0\0\377\227\377\377\377\377"
  "\212\377\0\0\377\205\377\377\377\377\213\377\377\377\0\205\377\377\377"
  "\377\210\377\0\0\377\235\377\377\377\377\210\377\0\0\377\204\377\377"
  "\377\377\211\377\377\377\0\205\377\377\377\377\207\377\0\0\377\241\377"
  "\377\377\377\207\377\0\0\377\204\377\377\377\377\207\377\377\377\0\205"
  "\377\377\377\377\206\377\0\0\377\245\377\377\377\377\206\377\0\0\377"
  "\204\377\377\377\377\205\377\377\377\0\205\377\377\377\377\206\377\0"
  "\0\377\246\377\377\377\377\206\377\0\0\377\205\377\377\377\377\204\377"
  "\377\377\0\205\377\377\377\377\205\377\0\0\377\247\377\377\377\377\206"
  "\377\0\0\377\205\377\377\377\377\203\377\377\377\0\205\377\377\377\377"
  "\205\377\0\0\377\264\377\377\377\377\202\377\377\377\0\204\377\377\377"
  "\377\205\377\0\0\377\265\377\377\377\377\202\377\377\377\0\204\377\377"
  "\377\377\204\377\0\0\377\266\377\377\377\377\1\377\377\377\0\204\377"
  "\377\377\377\205\377\0\0\377\273\377\377\377\377\204\377\0\0\377\273"
  "\377\377\377\377\205\377\0\0\377\205\377\377\377\377\204000\377\216\377"
  "\377\377\377\204000\377\206\377\377\377\377\215000\377\215\377\377\377"
  "\377\204\377\0\0\377\206\377\377\377\377\205000\377\214\377\377\377\377"
  "\205000\377\206\377\377\377\377\217000\377\213\377\377\377\377\204\377"
  "\0\0\377\206\377\377\377\377\205000\377\214\377\377\377\377\205000\377"
  "\206\377\377\377\377\220000\377\212\377\377\377\377\204\377\0\0\377\206"
  "\377\377\377\377\206000\377\212\377\377\377\377\206000\377\206\377\377"
  "\377\377\204000\377\207\377\377\377\377\205000\377\212\377\377\377\377"
  "\204\377\0\0\377\206\377\377\377\377\207000\377\210\377\377\377\377\207"
  "000\377\206\377\377\377\377\204000\377\210\377\377\377\377\205000\377"
  "\211\377\377\377\377\204\377\0\0\377\206\377\377\377\377\207000\377\210"
  "\377\377\377\377\207000\377\206\377\377\377\377\204000\377\211\377\377"
  "\377\377\204000\377\211\377\377\377\377\204\377\0\0\377\206\377\377\377"
  "\377\210000\377\206\377\377\377\377\210000\377\206\377\377\377\377\204"
  "000\377\211\377\377\377\377\204000\377\211\377\377\377\377\204\377\0"
  "\0\377\206\377\377\377\377\211000\377\204\377\377\377\377\211000\377"
  "\206\377\377\377\377\204000\377\211\377\377\377\377\204000\377\211\377"
  "\377\377\377\204\377\0\0\377\206\377\377\377\377\204000\377\1\377\377"
  "\377\377\205000\377\202\377\377\377\377\205000\377\1\377\377\377\377"
  "\204000\377\206\377\377\377\377\204000\377\211\377\377\377\377\20400"
  "0\377\211\377\377\377\377\204\377\0\0\377\206\377\377\377\377\204000"
  "\377\202\377\377\377\377\212000\377\202\377\377\377\377\204000\377\206"
  "\377\377\377\377\204000\377\211\377\377\377\377\204000\377\211\377\377"
  "\377\377\204\377\0\0\377\206\377\377\377\377\204000\377\203\377\377\377"
  "\377\210000\377\203\377\377\377\377\204000\377\206\377\377\377\377\204"
  "000\377\211\377\377\377\377\204000\377\211\377\377\377\377\204\377\0"
  "\0\377\206\377\377\377\377\204000\377\204\377\377\377\377\206000\377"
  "\204\377\377\377\377\204000\377\206\377\377\377\377\204000\377\211\377"
  "\377\377\377\204000\377\211\377\377\377\377\204\377\0\0\377\206\377\377"
  "\377\377\204000\377\205\377\377\377\377\204000\377\205\377\377\377\377"
  "\204000\377\206\377\377\377\377\204000\377\210\377\377\377\377\20500"
  "0\377\211\377\377\377\377\204\377\0\0\377\206\377\377\377\377\204000"
  "\377\206\377\377\377\377\202000\377\206\377\377\377\377\204000\377\206"
  "\377\377\377\377\204000\377\207\377\377\377\377\205000\377\212\377\377"
  "\377\377\204\377\0\0\377\206\377\377\377\377\204000\377\206\377\377\377"
  "\377\202000\377\206\377\377\377\377\204000\377\206\377\377\377\377\220"
  "000\377\212\377\377\377\377\204\377\0\0\377\206\377\377\377\377\2040"
  "00\377\216\377\377\377\377\204000\377\206\377\377\377\377\217000\377"
  "\213\377\377\377\377\204\377\0\0\377\206\377\377\377\377\204000\377\216"
  "\377\377\377\377\204000\377\206\377\377\377\377\215000\377\215\377\377"
  "\377\377\204\377\0\0\377\206\377\377\377\377\204000\377\216\377\377\377"
  "\377\204000\377\206\377\377\377\377\204000\377\226\377\377\377\377\204"
  "\377\0\0\377\206\377\377\377\377\204000\377\216\377\377\377\377\2040"
  "00\377\206\377\377\377\377\204000\377\226\377\377\377\377\204\377\0\0"
  "\377\206\377\377\377\377\204000\377\216\377\377\377\377\204000\377\206"
  "\377\377\377\377\204000\377\226\377\377\377\377\204\377\0\0\377\206\377"
  "\377\377\377\204000\377\216\377\377\377\377\204000\377\206\377\377\377"
  "\377\204000\377\226\377\377\377\377\204\377\0\0\377\206\377\377\377\377"
  "\204000\377\216\377\377\377\377\204000\377\206\377\377\377\377\20400"
  "0\377\226\377\377\377\377\204\377\0\0\377\206\377\377\377\377\204000"
  "\377\216\377\377\377\377\204000\377\206\377\377\377\377\204000\377\226"
  "\377\377\377\377\204\377\0\0\377\206\377\377\377\377\204000\377\216\377"
  "\377\377\377\204000\377\206\377\377\377\377\204000\377\226\377\377\377"
  "\377\204\377\0\0\377\206\377\377\377\377\204000\377\216\377\377\377\377"
  "\204000\377\206\377\377\377\377\204000\377\226\377\377\377\377\204\377"
  "\0\0\377\206\377\377\377\377\204000\377\216\377\377\377\377\204000\377"
  "\206\377\377\377\377\204000\377\205\377\377\377\377\212\377\0\0\377\207"
  "\377\377\377\377\205\377\0\0\377\205\377\377\377\377\204000\377\216\377"
  "\377\377\377\204000\377\206\377\377\377\377\204000\377\205\377\377\377"
  "\377\212\377\0\0\377\207\377\377\377\377\205\377\0\0\377\205\377\377"
  "\377\377\204000\377\216\377\377\377\377\204000\377\206\377\377\377\377"
  "\204000\377\205\377\377\377\377\212\377\0\0\377\210\377\377\377\377\205"
  "\377\0\0\377\251\377\377\377\377\212\377\0\0\377\210\377\377\377\377"
  "\205\377\0\0\377\251\377\377\377\377\212\377\0\0\377\211\377\377\377"
  "\377\205\377\0\0\377\255\377\377\377\377\205\377\0\0\377\204\377\377"
  "\377\377\1\377\377\377\0\204\377\377\377\377\205\377\0\0\377\254\377"
  "\377\377\377\206\377\0\0\377\203\377\377\377\377\202\377\377\377\0\205"
  "\377\377\377\377\205\377\0\0\377\253\377\377\377\377\206\377\0\0\377"
  "\203\377\377\377\377\203\377\377\377\0\205\377\377\377\377\205\377\0"
  "\0\377\251\377\377\377\377\207\377\0\0\377\203\377\377\377\377\203\377"
  "\377\377\0\205\377\377\377\377\206\377\0\0\377\247\377\377\377\377\210"
  "\377\0\0\377\202\377\377\377\377\205\377\377\377\0\205\377\377\377\377"
  "\206\377\0\0\377\245\377\377\377\377\211\377\0\0\377\202\377\377\377"
  "\377\206\377\377\377\0\205\377\377\377\377\207\377\0\0\377\242\377\377"
  "\377\377\204\377\0\0\377\1\377\377\377\377\205\377\0\0\377\1\377\377"
  "\377\377\207\377\377\377\0\206\377\377\377\377\210\377\0\0\377\236\377"
  "\377\377\377\206\377\0\0\377\1\377\377\377\377\205\377\0\0\377\211\377"
  "\377\377\0\206\377\377\377\377\212\377\0\0\377\230\377\377\377\377\210"
  "\377\0\0\377\202\377\377\377\377\204\377\0\0\377\213\377\377\377\0\207"
  "\377\377\377\377\247\377\0\0\377\203\377\377\377\377\203\377\0\0\377"
  "\215\377\377\377\0\207\377\377\377\377\245\377\0\0\377\204\377\377\377"
  "\377\202\377\0\0\377\217\377\377\377\0\210\377\377\377\377\241\377\0"
  "\0\377\206\377\377\377\377\1\377\0\0\377\221\377\377\377\0\212\377\377"
  "\377\377\234\377\0\0\377\207\377\377\377\377\225\377\377\377\0\251\377"
  "\377\377\377\231\377\377\377\0\245\377\377\377\377\236\377\377\377\0"
  "\237\377\377\377\377\221\377\377\377\0"};




GMan::~GMan(void)
{

  cout << "~GMan:\n"; 

  free_list(manpath);

  // Delete everything in the mandirs list
  GList *gl;
  GList *nextnode;

  gl = mandirs;
  while (gl)
    {
      nextnode = gl->next;
      delete_mandir((ManDir *)gl->data);
      gl = nextnode;
    }
  g_list_free(mandirs);
  mandirs = NULL;

  //  cout << "~GMan: ABOUT to delete manpages\n";
  gl = manpages;
  while (gl)
    {
      nextnode = gl->next;
      delete_manpage((ManPage *)gl->data);
      gl = nextnode;
    }
  g_list_free(manpages);
  manpages = NULL;
  //  cout << "~GMan: DONE delete manpages\n";

  gl = edits;
  while (gl)
    {
      nextnode = gl->next;
      ((Edit *)gl->data)->do_quit(NULL, (Edit *)gl->data); 
      gl = nextnode;
    }
  g_list_free(edits);
  edits = NULL;
  //  cout << "~GMan: DONE delete edits\n";

  gl = apropos;
  while (gl)
    {
      nextnode = gl->next;
      delete_apropos((Apropos *)gl->data);
      gl = nextnode;
    }
  g_list_free(apropos);
  apropos = NULL;

  if (about)
    {
      About *ab = about;
      about = NULL;
      delete ab;
    }

  if (windowsizes)
    {
      Windowsizes *ws = windowsizes;
      windowsizes = NULL;
      delete ws;
    }

  if (printprefs)
    {
      delete printprefs;
      printprefs = NULL;
    }

  if (start_manpage)
    {
      free(start_manpage);
      start_manpage = NULL;
    }

   if (icon_pixbuf)
     {
       g_object_unref(G_OBJECT(icon_pixbuf));
       icon_pixbuf = NULL;
     }

}



// Both find_manpage and find_apropos can call the apropos module
// because both rely on the apropos command "apropos whatever".
// The format of the output is manpagename [abc] (section number) - information
// where [abc] (usually missing) represents the actual manpage when it is linked.
// The section number might have extra info e.g. (1x) or (3qt)
// Note that the section number is the section number of [abc]

bool GMan::do_manpage(GMan *g, char *manpage)
{
  Apropos *ap = new Apropos(g);

  g->apropos = g_list_append(g->apropos, ap);

// cout << "GMan::do_manpage - " << manpage << endl;

  if (!ap->search(manpage))
    {
      Complain *c = new Complain;
      string buffer;

      // No manpage was found
      g->apropos = g_list_remove(g->apropos, ap);
      delete ap; 


      // INFORM THE USER!
      // ================
      buffer = "Manpage \"";
      buffer += manpage;
      buffer += "\"  not found.";

      c->complain(c->CN_CONTINUE,
		  (char *)"SEARCH",
		  (char *)buffer.c_str(),
		  NULL,
		  NULL,
		  g);

      return FALSE;
    }
  return TRUE;
}


void GMan::find_manpage(GtkWidget *widget, GMan *g)
{
  gchar *manpage = gtk_editable_get_chars(GTK_EDITABLE(g->entry), 0, -1);

//  cout << "GMan::find_manpage: " << manpage << endl;

  do_manpage(g, manpage);

}

void GMan::find_apropos(GtkWidget *widget, GMan *g)
{
  string ap_string = gtk_editable_get_chars(GTK_EDITABLE(g->entry), 0, -1);

//  cout << "GMan::find_apropos: " << ap_string << endl;
  
  Apropos *ap = new Apropos(g);
  g->apropos = g_list_append(g->apropos, ap);
  ap->apropos((char *)ap_string.c_str());

}


// File menu
//===========
// Get the selected filename and print it to the console
// We need GMan *g to carry on from here...


void GMan::callback_open(GtkWidget *widget, GMan *g)
{  
cout << "GMan::callback_open" << endl;

GtkWidget *dialog = gtk_file_chooser_dialog_new ("OPEN for View",
                                      GTK_WINDOW(g->window),
                                      GTK_FILE_CHOOSER_ACTION_OPEN,
                                      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                                      NULL);


if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	{
  char *pathname;
	string name;
	char *c;
		
	pathname = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
	c = &pathname[strlen(pathname) - 1];

	while ( (c >= pathname) && (*c != '/') )
		{
		name = *c-- + name;
		}
	cout << "GMan::callback_open - Pathname= " << pathname << endl;
	cout << "                          name= " << name << endl;

  ManPage *manpage = new ManPage(g);
  g->manpages = g_list_append(g->manpages, manpage);
  manpage->load_manpage((char *)"", pathname, (char *)name.c_str());
	g_free (pathname);
  }
	
else cout << "GMan::callback_open - NO RESULT" << endl;

gtk_widget_destroy (dialog);
}


void GMan::load_selected(GtkWidget *widget, string pathname, GMan *g)
{
string sourcebuf;
string command;

cout << "GMan::load_selected - got " << pathname << endl;

if (isfile((char *)pathname.c_str()))
  {
  if ( SUFEQ((char *)pathname.c_str(), (char *)".gz" ) )
	  {
    command = "gunzip -c ";
	  }
  else if ( SUFEQ((char *)pathname.c_str(), (char *)".bz2" ) )
	  {
    command = "bunzip2 -c ";
	  }
  else
	  {
    command = "cat ";
	  }
  command += pathname;

  sourcebuf = get_file(command );

  Edit *edit = new Edit(g, (char *)pathname.c_str(), (char *)sourcebuf.c_str());
  g->edits = g_list_append(g->edits, edit); 


//      cout << "GMan::load_selected - ABOUT to g->close_file_requester\n";
//  g->close_file_requester(widget, g);
  }
else if ( isname((char *)pathname.c_str()) )  // ANYTHING ELSE EXISTS, ERROR 
  {
  Complain *c = new Complain;
  string buffer = "System name \"";;
  buffer += pathname;
  buffer += "\" exists but is not a regular file.\n";
  buffer += "Can't load it.\n";

  cout << "Edit::load_selected \"" << pathname << "\" exists and is not a regular file.\nCan't load it.\n";

  c->complain(c->CN_CANCEL,
  (char *)"Edit",
  (char *)buffer.c_str(),
  NULL,
  NULL,
  (gpointer)g);
  }
else
  {
  Complain *c = new Complain;
  string buffer = "System name \"";;
  buffer += pathname;
  buffer += "\" doesn't exist.\n";
  buffer += "Can't load it.\n";

  cout << "Edit::load_selected - name \"" << pathname << "\" doesn't exist, can't load it\n";

  c->complain(c->CN_CANCEL,
  (char *)"Edit",
  (char *)buffer.c_str(),
  NULL,
  NULL,
  (gpointer)g);
  }
}

void GMan::callback_new_edit(GtkWidget *widget, GMan *g)
{
cout << "GMan::callback_new_edit\n";

Edit *edit = new Edit(g, (char *)"", (char *)"");
g->edits = g_list_append(g->edits, edit); 
}




void GMan::callback_load_for_edit(GtkWidget *widget, GMan *g)
{  
cout << "GMan::callback_load_for_edit" << endl;

GtkWidget *dialog = gtk_file_chooser_dialog_new ("LOAD for Edit",
                                      GTK_WINDOW(g->window),
                                      GTK_FILE_CHOOSER_ACTION_OPEN,
                                      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                                      NULL);


if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	{
  char *pathname;
	string name;
	char *c;
		
	pathname = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
	c = &pathname[strlen(pathname) - 1];

	while ( (c >= pathname) && (*c != '/') )
		{
		name = *c-- + name;
		}
	cout << "GMan::callback_load_for_edit - Pathname= " << pathname << endl;
	cout << "                          name= " << name << endl;

	g->load_selected(widget, pathname, g);

	g_free (pathname);
  }
	
else cout << "GMan::callback_load_for_edit - NO RESULT" << endl;


gtk_widget_destroy (dialog);
}



void GMan::callback_quit(GtkWidget *widget, Quit *q)
{
  gtk_main_quit();
  q->process_error(E_QUIT);
}

// Options menu
//==============
void GMan::callback_windowsizes(GtkWidget *widget, GMan *g)
{
//  cout << "GMan::callback_windowsizes\n";
  if (g->windowsizes == NULL)
    g->windowsizes = new Windowsizes(g);
}

void GMan::callback_printprefs(GtkWidget *widget, GMan *g)
{
//  cout << "GMan::callback_printprefs\n";

  if (g->printprefs == NULL)
    g->printprefs = new Printprefs(g);
}

void GMan::callback_edit_prefs(GtkWidget *widget, GMan *g)
{
cout <<  "GMan::callback_edit_prefs" << endl;
if (g->ep == NULL)
  {
  g->ep = new EditPrefs(g);
  }
else cout << "GMan::callback_edit_prefs - Editor Preferences window is already open" << endl;
}

// Sections menu
//===============
void GMan::chose_section(GtkWidget *widget, Section *man_section)
{

//  cout << "GMan::chose_section - chose " << man_section->name << "\n";
  ManDir *md = new ManDir(man_section->g);

  man_section->g->mandirs = g_list_append(man_section->g->mandirs, md);

  md->choose_manpage((char *)man_section->name.c_str());
}

// Help menu
//===========
void GMan::callback_help(GtkWidget *widget, GMan *g)
{
//  cout << "GMan::callback_help\n";
  do_manpage(g, (char *)"gmanpage");
}
void GMan::callback_about(GtkWidget *widget, GMan *g)
{
  if (g->about == NULL)
    g->about = new About(g, (char *)"ABOUT");
}


// Delete an entry in the mandirs list
void GMan::delete_mandir(ManDir *mandir)
{
  // If mandir is in the list
  //   remove the node from the mandirs list
  //   "delete" it (includes shut down it's window)
  if (g_list_find(mandirs, mandir))
    {
      mandirs = g_list_remove(mandirs, mandir);
      delete mandir;      
    }
}

// Delete an entry in the manpages list
void GMan::delete_manpage(ManPage *manpage)
{
  // If manpage is in the list
  //   remove the node from the manpage list
  //   "delete" it (includes shut down it's window)
  if (g_list_find(manpages  , manpage))
    {
      manpages = g_list_remove(manpages, manpage);
      delete manpage;      
    }
}

/***********************************************
// Delete an entry in the edits list
void GMan::delete_edit(Edit *edit)
{
  
cout << "GMan::delete_edit" << endl;

  // If edit is in the list
  //   remove the node from the edit list
  //   "delete" it (includes shut down it's window)
if (g_list_find(edits, edit))
  {
cout << "GMan::delete_edit - found edit" << endl;
  edits = g_list_remove(edits, edit);
cout << "GMan::delete_edit - removed edit from list" << endl;

  delete edit;
cout << "GMan::delete_edit - DONE" << endl;    
  }
}
**********************************************/
void GMan::delete_apropos(Apropos *ap)
{
  if (g_list_find(apropos, ap))
    { 
      // Remove from list BEFORE delete to prevent a double delete
      apropos = g_list_remove(apropos, ap);
      delete ap;      
    }
}

void GMan::delete_about(About *about)
{
  if (about)
    {
      GMan *g = about->gman;
	
      //cout << "ENTERED delete about\n";
 
      if (g->about)
	delete about; 
      g->about = NULL;
    }
 }

void GMan::delete_windowsizes(class Windowsizes *ws)
{
  if (ws)
    {
      GMan *g = windowsizes->gman;
	
      if (g->windowsizes) delete ws; 
      g->windowsizes = NULL;
    }
 }

void GMan::delete_printprefs(class Printprefs *printprefs)
{
  if (printprefs)
    {
      GMan *g = printprefs->gman;
	
      if (g->printprefs) delete printprefs; 
      g->printprefs = NULL;
    }
 }


// We need to test the "grab_widget" for the widget that caused this event
// It isn't the same

/**************************
 * Check for "Return" key *
 **************************/

void GMan::key_event(GtkWidget *widget, GdkEventKey *event, GMan *g)
{

//cout << "GMan::key_event - gdk_keyval_name= " << gdk_keyval_name(event->keyval) << endl;

if ( (string)gdk_keyval_name(event->keyval) == "Return" )
	{
	if (widget == g->window) g->find_manpage(NULL, g);
	}

return;
}



void GMan::window_exposed(GtkWidget *widget, GMan *g)
{
using namespace misc;

cout <<   "GMan::window_exposed - ENTERED\n";

g_signal_handler_disconnect(G_OBJECT(widget), g->expose_signal); //gtk_signal_disconnect(G_OBJECT(widget), g->expose_signal);
g->expose_signal = 0;
  
if (g->start_manpage && (*(g->start_manpage)) )
  {
//  cout << "GMan::window_exposed - starting " << g->start_manpage << endl;
//  We want start_manpage displayed

//  THIS NEEDS TO CHECK IF IT IS ACTUALLY A FILE - "/" in pathname or "." in the name
//  If so, load the file instead 


  if (isfile(g->start_manpage))
    {
    char *name = &g->start_manpage[strlen(g->start_manpage)];

    while (name > g->start_manpage)
      {
      if ( *(name - 1) == '/' ) break;
      --name;
      }

    ManPage *manpage = new ManPage(g);
    g->manpages = g_list_append(g->manpages, manpage);
    manpage->load_manpage((char *)"", g->start_manpage, name);

    }
  else do_manpage(g, g->start_manpage);

  }

	
while (gtk_events_pending ())
  gtk_main_iteration ();

}



GMan::GMan(int argc, char *argv[], Quit *quit)
{
using namespace misc;

GtkWidget *vbox, *hbox;
GtkWidget *widget;
GtkWidget *menu;
GtkWidget *menubar;
GtkWidget *menuitem;
int n;  
list<string>::iterator i;

string menu_name;  
string menu_accel;
string menu_tip; 
  
  
// Process the manpath into a GList for future reference
if ( process_manpath()== FALSE)
  {
  q->process_error(E_NO_MANPATH);
  return;
  }
  

cout << "GMan::\n"; 


start_manpage = ( (argc == 2) ? make_string(argv[1]) : NULL );

if (start_manpage) cout << "GMan:: start_manpage= " << start_manpage << endl;
q = quit;
mandirs = NULL;
accel_group = NULL;
//tooltips = NULL;
about = NULL;
windowsizes = NULL;
ep = NULL;

// if not in X we quit with error to cerr

if (! (getenv("DISPLAY")) )
  {
  q->process_error(E_NO_X);
  return;
  }

// Now process the manpath into a GList for future reference
if ( process_manpath()== FALSE)
  {
  q->process_error(E_NO_MANPATH);
  return;
  }

gtk_init (&argc, &argv);
  
window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
if (! (window) ) q->process_error(E_NO_WINDOW);

gtk_window_set_title(GTK_WINDOW(window), "gmanpage");

//gtk_widget_set_size_request (window, //220, 100);
//			       prefs.get_main_window_width(), 
//			       prefs.get_main_window_height() );
	
gtk_window_set_default_size(GTK_WINDOW(window),
 			       prefs.get_main_window_width(), 
			       prefs.get_main_window_height() );
                            
icon_pixbuf = gdk_pixbuf_new_from_inline(-1,
					   icon_pixbuf_source,
					   FALSE,
					   NULL);

gtk_window_set_icon( GTK_WINDOW(window), icon_pixbuf);

g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (gtk_main_quit),
		    NULL);

expose_signal = g_signal_connect (G_OBJECT (window),
        "draw",
        G_CALLBACK(window_exposed), (gpointer)this);

vbox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 4); //vbox = gtk_vbox_new(FALSE, 4);

gtk_container_add (GTK_CONTAINER (window), vbox);


hbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);


// --- Menu Bar ---
menubar = gtk_menu_bar_new ();
gtk_container_add(GTK_CONTAINER(hbox), menubar);

// --- File menu ---

menu = create_bar_submenu(menubar, (char *)"File");

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Open for view",
                            accel_group, (char *)"^O", 
                            (char *)"Open a manpage file to view", 
  			                    (void *)(callback_open),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"New edit",
                            accel_group, (char *)"^E", 
                            (char *)"Open a blank edit window", 
  			                    (void *)(callback_new_edit),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Load for edit",
                            accel_group, (char *)"^L", 
                            (char *)"Open a manpage file source for edit", 
  			                    (void *)(callback_load_for_edit),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Quit",
                            accel_group, (char *)"^Q", 
                            (char *)"Quit gman, close all windows", 
  			                    (void *)(callback_quit),
			                      (gpointer)q);


// --- Options menu ---

menu = create_bar_submenu(menubar, (char *)"Options");

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Window Sizes",
                            accel_group, (char *)"^W", 
                            (char *)"Configure personal window sizes", 
  			                    (void *)(callback_windowsizes),
			                      (gpointer)this);

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Printer Preferences",
                            accel_group, (char *)"^P", 
                            (char *)"Configure printing preferences", 
  			                    (void *)(callback_printprefs),
			                      (gpointer)this);



menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Editor Preferences",
                            accel_group, (char *)"",
                            (char *)"Select editor auto-save preferences", 
  			                    (void *)(callback_edit_prefs),
			                      (gpointer)this);
  

// --- Sections menu ---

menu = create_bar_submenu(menubar, (char *)"Sections");

for (n=0, i=section_num_list.begin(); i!=section_num_list.end(); ++i, ++n)
  {
  Section *section = new Section;
  // Get the section name
  string str = "man";
  str += *i;
  section->name = str;
  section->g = this;
  section_list.push_back(section);
    
/*
     Standard Man Pages:-
       1      User Commands
       2      System Calls
       3      C Library Functions
       4      Devices and Special Files
       5      File Formats and Conventions
       6      Games etc.
       7      Miscellaneous
       8      System Administration tools and Daemons                           
*/
                           
  if (*i=="1")
    {
    menu_name  = "1 - User Commands";  
    menu_accel = "^1";
    menu_tip   = "Commands available from the command line"; 
    }
  else if (*i=="2")
    {
    menu_name  = "2 - System Calls";  
    menu_accel = "^2";
    menu_tip   = "Programming system subroutines"; 
    }
  else if (*i=="3")
    {
    menu_name  = "3 - C Library Functions";  
    menu_accel = "^3";
    menu_tip   = "C Programming subroutines"; 
    }
  else if (*i=="4")
    {
    menu_name  = "4 - Devices and Special Files";  
    menu_accel = "^4";
    menu_tip   = "Devices, Special Files..."; 
    }
  else if (*i=="5")
    {
    menu_name  = "5 - File Formats and Conventions";  
    menu_accel = "^5";
    menu_tip   = "Formats of various different files"; 
    }
  else if (*i=="6")
    {
    menu_name  = "6 - Games etc.";  
    menu_accel = "^6";
    menu_tip   = "Enjoy!"; 
    }
  else if (*i=="7")
    {
    menu_name  = "7 - Miscellaneous";  
    menu_accel = "^7";
    menu_tip   = "Manpages that don't fit anywhere else"; 
    }
  else if (*i=="8")
    {
    menu_name  = "8 - System Administration tools and Daemons";  
    menu_accel = "^8";
    menu_tip   = "Manpages for administrative tasks"; 
    }
  else if (*i=="9")
    {
    menu_name  = "9 - Kernal Routines (non-standard)";  
    menu_accel = "^9";
    menu_tip   = "What's this?"; 
    }
  else if (*i=="n")
    {
    menu_name  = "n - New";  
    menu_accel = "^N";
    menu_tip   = "New manpages"; 
    }
  else                        
    {
    menu_name  = *i;
    menu_name += " - (non-standard)";
    menu_accel = "";
    menu_tip   = "What's this?"; 
    }                     
                           
  menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)menu_name.c_str(),
                            accel_group, (char *)menu_accel.c_str(), 
                            (char *)menu_tip.c_str(), 
  			                    (void *)(chose_section),
			                      (gpointer)(section));

  }

             
// --- Help menu ---

menu = create_bar_submenu(menubar, (char *)"Help");

menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"About",
                            accel_group, (char *)"^A", 
                            (char *)"Info about gmanpage", 
  			                    (void *)(callback_about),
			                      (gpointer)this);
             
menuitem = create_menuitem (window,
                            menu, 
  			                    (char *)"Help",
                            accel_group, (char *)"^H", 
                            (char *)"The manual page of gmanpage ", 
  			                    (void *)(callback_help),
			                      (gpointer)this);
             


hbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);


	
widget = gtk_label_new ("Search string: ");
gtk_misc_set_padding (GTK_MISC (widget), 2, 1);
gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, TRUE, 0);

	
entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 100);
gtk_entry_set_text (GTK_ENTRY (entry), "");
g_signal_connect(window, "key-release-event", G_CALLBACK(key_event), this);
gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);




hbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);

	
widget = gtk_button_new_with_label("Manual Page"); // "Man/Info Page");
g_signal_connect (G_OBJECT (widget), "clicked", // "button_press_event",
		    G_CALLBACK (find_manpage), (gpointer)this);
gtk_widget_set_can_default(GTK_WIDGET(widget), TRUE); //GTK_WIDGET_SET_FLAGS(widget, GTK_CAN_DEFAULT);

	
gtk_widget_set_tooltip_text(GTK_WIDGET(widget),
			  "Manual Page\nDisplays the selected search string as a manual page.\nIf there is more than one with the same name,\nthey are all shown in their own windows.");


gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, TRUE, 0);



	
widget = gtk_button_new_with_label ("Apropos");

g_signal_connect (G_OBJECT (widget), "clicked",
		    G_CALLBACK (find_apropos), (gpointer)this);
gtk_widget_set_can_default(GTK_WIDGET(widget), TRUE); //GTK_WIDGET_SET_FLAGS(widget, GTK_CAN_DEFAULT);
gtk_widget_set_tooltip_text(GTK_WIDGET(widget),
			  "Apropos\nDisplays a list of man pages which have\nthe selected search string in their info.\nAn entry can be selected to display that manual page.");


gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, TRUE, 0);



widget = gtk_button_new_with_label("QUIT");
g_signal_connect (G_OBJECT (widget), "clicked",
		      G_CALLBACK (callback_quit), (gpointer)q);

gtk_widget_set_can_default(GTK_WIDGET(widget), TRUE); //GTK_WIDGET_SET_FLAGS(widget, GTK_CAN_DEFAULT);

gtk_widget_set_tooltip_text(GTK_WIDGET(widget),
			  "QUIT\nTerminates the program closing all open windows.");


gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, TRUE, 0);

gtk_widget_show_all(window);
gtk_main ();

}


gboolean GMan::process_manpath(void)
{
using namespace misc;

string pathstring;
char *p;
char *ep;
char t = 0;
  
// cout << "GMan::process_manpath - ENTERED" << endl;
    
pathstring = get_file("manpath");

if (!pathstring.empty())
  {
  p = (char *)&pathstring.c_str()[0];

  while (*p)
	  {
	  ep = p;

	  for (;;)
	    {	      
      if ((*ep == ':') || (*ep == 0) || (*ep == '\n') )
		    {
		    t = *ep;
		    *ep = 0;
		    break;
		    }
      ep++;
	    }

	  if (strlen(p)) manpath = g_list_append(manpath, (make_string(p)));

	  *ep = t;

	  if (t == 0) break;

	  p = ep + 1;
	  while ((*p == ' ') || (*p == '\t')) p++;
	  }
  }

if (manpath)
  {
  // Get the available sections
  DIR    *dp;                   // Directory pointer
  struct dirent *direntry;      // This directory entry
  GList *manlist = manpath;
  char *section_num;
    
  while (manlist)
    {
    dp = opendir((char *)manlist->data);

// cout << "GMan::process_manpath - directory= " << (char *)manlist->data << endl;

    if (dp)
      {
      while ( (direntry = readdir(dp)) )
	      {
        if (STREQN(direntry->d_name, (char *)"man", 3))
          {
          section_num_list.push_back(&direntry->d_name[3]);
          }      
        }
      closedir(dp);
      }
    manlist = manlist->next;
    }
 
  section_num_list.sort();
  section_num_list.unique();
  }
return( (manpath) ? TRUE : FALSE );
}
 
