/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       mandir.h                                                  *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       16-Mar-2013 13.44.51 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __MANDIR_H__
#define __MANDIR_H__

#include <iostream>

#include <dirent.h>
#include <sys/types.h>
#include <string.h>
#include <gtk/gtk.h>
#include "list"

#include "manpage.h"
#include "gman.h"

using namespace std;


class ManDir
{
 public:
  ManDir(class GMan *gman);
  ~ManDir(void);

  void delete_manpage(class ManPage *manpage);
  void choose_manpage(char *man_section);

  void create_mandir_box(GtkWidget *box, char *man_section);
  void display_directory(GtkWidget *listbox, char *full_mname);
  void add_man_name(GtkWidget *listbox,
		    char *display_name, char *pathname);
  

  void add_to_lists(char *display_name, 
		   char *pathname, 
		   GList *start_dn, 
		   GList *start_mp);

  GtkWidget *window;
  GMan *g;
  GList *mandirs;

  GList *manpages;  // child windows of a ManPage each

 private:
  static void CloseDialog (GtkWidget *widget, ManDir *md);
  static void callback_page_selected(GtkWidget *widget, ManDir *md);
  GtkWidget *create_view_and_model(void);
  int add_to_view(GtkWidget *view, string full_mname, char *man_section);


  list<GtkWidget *> view_list;

  GList *pathnames;
  GList *display_names;
  GdkPixbuf *pixbuf;

 protected:

};







#endif // _MANDIR_H
