/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       misc.h                                                    *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       29-Mar-2013 10.56.55 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __MISC_H__
#define __MISC_H__

#include <iostream>
#include <sstream>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <gtk/gtk.h>

using namespace std;

namespace misc

{
gboolean isfile(char *pathname);
gboolean isname(char *pathname);
gboolean get_fsize(char *fname, size_t *size);

//char *get_file(char *command, char *fname);
string get_file(string command);

GList *get_tail_node(GList *list);
int compare_list(GList *list, char *string);
gint glist_index(GList *list, char *string);
void free_list(GList *list);
void decorate_widget(GtkWidget *widget, GdkRGBA *fg_normal, GdkRGBA *bg_normal,  GdkRGBA *bg_prelight, const gchar *stock_id);

void SetComboTextList(GtkWidget *combo, GList *list);
GtkWidget *CreateCombobox (GList *list);
GtkWidget *create_spinner(int s_start, int s_min, int s_max);
GtkWidget *create_hspinner(GtkWidget **hspinner, double s_start, double s_min, double s_max);

GtkWidget *create_bar_submenu(GtkWidget *menubar, char *name);
GtkWidget *create_menuitem (GtkWidget *window,
                            GtkWidget *menu, 
                            char *name,
                            GtkAccelGroup *accel_group, char *accel,
				                    char *tip, 
				                    void *func,
				                    gpointer data);
				  
int suficmp(char *string, char *suffix);
int sufcmp(char *string, char *suffix);
char *make_string(char *string);
double string_to_double( const std::string& s );

	
int STREQ(char *x, char *y);
int STRIEQ(char *x, char *y);
int STREQN(char *x, char *y, int n);
int STRIEQN(char *x, char *y, int n);
int SUFEQ(char *x, char *y);
int SUFIEQ(char *x, char *y);
};


static GdkRGBA red           = { 1.0, 0.0, 0.0, 1.0};
static GdkRGBA black         = { 0.0, 0.0, 0.0, 1.0};
static GdkRGBA white         = { 1.0, 1.0, 1.0, 1.0};

static GdkRGBA  lightgreen   = {0.1, 0.9,   0.1,   1.0};
static GdkRGBA  lightyellow  = {0.8, 0.8,   0.0,   1.0};
static GdkRGBA  pink         = {1.0, 0.1,   0.5,   1.0};
static GdkRGBA  lightblue    = {0.5, 0.5,   1.0,   1.0};
static GdkRGBA  darkblue     = {0.1, 0.1,   0.9,   1.0};
static GdkRGBA  darkred      = {0.7, 0.0,   0.0,   1.0};
static GdkRGBA  darkgreen    = {0.1, 0.5,   0.1,   1.0};
static GdkRGBA  brown       =  {0.4, 0.1,   0.1,   1.0};


#endif // _MISC_H
