/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       prefs.cpp                                                 *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       13-Mar-2013 16.09.39 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Various preferences routines                                              *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#include "prefs.h"
#include <iostream>
#include <fstream>
#include <sys/types.h>
#include <pwd.h>
#include <gtk/gtk.h>

#include "misc.h"

using namespace std;
using namespace misc;

struct Media Prefs::media[30] =
    {
      { "Comm #10 Envelope", 297,  684 },
      { "C5 Envelope",       461,  648 },
      { "DL Envelope",       312,  624 },
      { "Folio",             595,  935 },
      { "Executive",         522,  756 },
      { "Letter",            612,  792 },
      { "Legal",             612, 1008 },
      { "Ledger",           1224,  792 },
      { "Tabloid",           792, 1224 },
      { "A0",               2384, 3370 },
      { "A1",               1684, 2384 },
      { "A2",               1191, 1684 },
      { "A3",                842, 1191 },
      { "A4",                595,  842 },
      { "A5",                420,  595 }, 
      { "A6",                297,  420 },
      { "A7",                210,  297 },
      { "A8",                148,  210 },
      { "A9",                105,  148 },
      { "B0",               2920, 4127 },
      { "B1",               2064, 2920 },
      { "B2",               1460, 2064 },
      { "B3",               1032, 1460 },
      { "B4",                729, 1032 },
      { "B5",                516,  729 },
      { "B6",                363,  516 },
      { "B7",                258,  363 },
      { "B8",                181,  258 },
      { "B9",                127,  181 },
      { "B10",                91,  127 }
    };


//  d_n_pcolour  = 0x00000000; // black
//  d_i_pcolour  = 0x00FF0000; // red
//  d_b_pcolour  = 0x00000000; // black
//  d_eb_pcolour = 0x000000FF; // blue
//  d_er_pcolour = 0x00FF00FF; // violet sort of...

		
  double Prefs::d_n_p_red   = 0.0;
  double Prefs::d_n_p_green = 0.0;
  double Prefs::d_n_p_blue  = 0.0;

  double Prefs::d_i_p_red   = 1.0;
  double Prefs::d_i_p_green = 0.0;
  double Prefs::d_i_p_blue  = 0.0;

  double Prefs::d_b_p_red   = 0.0;
  double Prefs::d_b_p_green = 0.0;
  double Prefs::d_b_p_blue  = 0.0;

  double Prefs::d_eb_p_red   = 0.0;
  double Prefs::d_eb_p_green = 0.0;
  double Prefs::d_eb_p_blue  = 1.0;

	double Prefs::d_er_p_red   = 1.0;
  double Prefs::d_er_p_green = 0.0;
  double Prefs::d_er_p_blue  = 1.0;



string  Prefs::fonts[3] =
  {
    "Times",
    "Helvetica",
    "Courier"
  };


Prefs::Prefs(void)
{
  cout << "Prefs:\n";

  pathname = (getpwnam( (getpwuid( getuid() ))->pw_name ))->pw_dir;
  pathname += "/gmanpage.prefs";

  d_printername = "";     // DEFAULTS
  d_papersize.size = "A4";
  d_papersize.width = 595;
  d_papersize.height = 842;
  d_l_margin = 10;
  d_r_margin = 10;
  d_t_margin = 10;
  d_b_margin = 10;
  d_fontname = "Times";
  d_fontsize = 11;
  d_fixed = TRUE;
  d_preview_command = "gv";




	
  d_main_window_width     = 220;
  d_main_window_height    = 100;
  d_manpage_width         = 660;
  d_manpage_height        = 420;
  d_mandir_width          = 300;
  d_mandir_height         = 500;
  d_edit_width            = 660;
  d_edit_height           = 420;
  d_apropos_width         = 300;
  d_apropos_height        = 360;
  d_printprefs_width      = 420;
  d_printprefs_height     = 420;
  d_displayprefs_width    = 460;
  d_displayprefs_height   = 400;
  d_editprefs_width       = 460;
  d_editprefs_height      = 400;
  
  d_about_width           = 470;
  d_about_height          = 440;

  d_autosave_seconds      = 0;
  d_autosave_changes      = 0;

  load();
}

Prefs::~Prefs(void)
{
cout << "~Prefs:\n";
}

gint Prefs::get_main_window_height(void)
{
return(main_window_height);
}
gint Prefs::get_main_window_width(void)
{
return(main_window_width);
}
gint Prefs::get_about_height(void)
{
return(about_height);
}
gint Prefs::get_about_width(void)
{
return(about_width);
}
gint Prefs::get_apropos_height(void)
{
  return(apropos_height);
}
gint Prefs::get_apropos_width(void)
{
return(apropos_width);
}
gint Prefs::get_manpage_height(void)
{
return(manpage_height);
}
gint Prefs::get_manpage_width(void)
{
return(manpage_width);
}
gint Prefs::get_mandir_height(void)
{
return(mandir_height);
}
gint Prefs::get_mandir_width(void)
{
return(mandir_width);
}
gint Prefs::get_edit_height(void)
{
return(edit_height);
}
gint Prefs::get_edit_width(void)
{
return(edit_width);
}
guint Prefs::get_autosave_seconds(void)
{
return(autosave_seconds);
}
int Prefs::get_autosave_changes(void)
{
return(autosave_changes);
}
string *Prefs::get_preview_command(void)
{
return(&preview_command);
}

bool Prefs::IsWhiteSpace(char x) // except for newline
{
  return ((x == ' ')||(x == '\t'));
}

bool Prefs::IsSeparator(char x)
{
  return ((x == ' ')||(x == '\t')||(x == '=')||(x == ':'));
}

// This should allow quoted strings...
void Prefs::getright(string &s, string &v)
{
  unsigned int p=0;
  bool inquote = FALSE;

  v = "";  // start with an empty string!

  while ( (p < s.length()) && IsWhiteSpace(s[p]) )
	{
	  p++;
	}

  if ( (p < s.length()) && ((s[p]=='=') || (s[p]==':')) )
    {
      p++;
      while ( (p < s.length()) && IsWhiteSpace(s[p]) )
	{
	  p++;
	}
    }

  while (p < s.length())
    {
      if (s[p] == '\"')
	{
	  inquote = !inquote;
	  p++;
	  continue;
	}

      // If any of these the rest of the line is ignored unless in quote
      if ( (!inquote) &&
	   (IsWhiteSpace(s[p]) || (s[p]=='#') || (s[p]==';') || (s[p]=='\n')) ) break;

      v += s[p];
      p++;
    }
}


int Prefs::get_int(string &v)
{
  int i;

  if ( (v[0] == '$') || (v.substr(0,2) == "0x") )
    {
      // Use v[1] for hex
      if (v[0] == '$') v = v.substr(1);
      else v = v.substr(2);

      i = 0;

      for (unsigned int n=0; n<v.length(); n++)
	{
	  i *= 16;

	  if ( (v[n] >= '0' ) && (v[n] <= '9' ) )
	    {
	      i += (v[n] - '0');
	    }
	  else
	    {
	      char c = toupper(v[n]);
	      if ( (c >= 'A') && (c <= 'F') )
		{
		  i += (c - 'A' + 10);
		}
	      else
		{
		  // INVALID CHARACTER so quit
		  break;
		}
	    }
	}
    }



  else i = atoi((char *)v.c_str()); // assume decimal

  return(i);
}


// Convert an int to an ascii hex string
// The int in n, the output in v
void Prefs::i2hex(int n, string &v, bool uppercase)
{
  unsigned long rem;                // remainder
  unsigned long num = n;            // the current number
  string t = "";

  do
    {
      rem = num % 16;
      num = num / 16;

      if (rem >= 10)
	{
	  if (uppercase)
	    rem += 'A' - 10;
	  else
	    rem += 'a' - 10;
	}
      else rem += '0';
      t += rem;
    } while (num > 0);

  // We want all 8 characters
  while (t.length() < 8) t += '0';

  // reverse the string into v
  v = "0x";
  for (int i = t.length() - 1;  i>=0; --i)
    {
      v += t[i];
    } 
}


bool Prefs::getline(fstream &ifp, string &line)
{
  char c;

  line = "";
  while ( !ifp.eof() )
    {
      ifp.get(c);
      if (ifp.eof()) return FALSE;
      if ((c == 0x0a) || (c == 0)) break;
      line += c;
    }
  return TRUE;
}


// Load preferences
void Prefs::load(void)
{
  fstream ifp;

  bool pn, sz, wd, ht, lm, rm, tm, bm, fn, fs, fx, pv,
	nr, ng, nb, ir, ig, ib, br, bg, bb, ebr, ebg, ebb, err, erg, erb,
    mww, mwh, mdw, mdh, mpw, mph, ew, eh, apw, aph, ppw, pph, dpw, epw, eph,
    dph, aw, ah, ass, asc;

  pn = sz = wd = ht = lm = rm = tm = bm = fn = fs = fx = pv =
    nr = ng = nb = ir = ig = ib = br = bg = bb =
		ebr = ebg = ebb = err = erg = erb = mww = mwh = mdw = mdh = mpw = mph =
    ew = eh = apw = aph = ppw = pph = dpw = dph = epw = eph = aw = ah =
    ass = asc = FALSE;

  //cout << "Prefs::load: pathname= " << pathname << endl;

  ifp.open(pathname.c_str(), ios::in | ios::binary );
  if ( ifp.is_open() )
    {
      string line;
      string v;
      string s;

      while ( getline(ifp, line) )
	{
	  //cout << "Prefs::load: GOT>> \"" << line << "\"" << endl;

	  if ((line[0] == '#') || (line[0] == ';')) continue; // comment line


	  if (STRIEQN((char *)"PRINTERNAME", (char *)line.c_str(), 11) && IsSeparator(line[11]) )
	    {
	      s = line.substr(11);
	      getright(s, v);
	      printername = v;
	      pn = TRUE;
	    }
	  else if (STRIEQN((char *)"SIZE", (char *)line.c_str(), 4) && IsSeparator(line[4]) )
	    {
	      s = line.substr(4);
	      getright(s, v);
	      papersize.size = v;
	      sz = TRUE;
	    }
	  else if (STRIEQN((char *)"WIDTH", (char *)line.c_str(), 5) && IsSeparator(line[5]) )
	    {
	      s = line.substr(5);
	      getright(s, v);
	      papersize.width =get_int(v);
	      wd  = TRUE;
	    }
	  else if (STRIEQN((char *)"HEIGHT", (char *)line.c_str(), 6) && IsSeparator(line[6]) )
	    {
	      s = line.substr(6);
	      getright(s, v);
	      papersize.height =get_int(v);
	      ht = TRUE;
	    }
	  else if (STRIEQN((char *)"L_MARGIN", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	      s = line.substr(8);
	      getright(s, v);
	      l_margin = get_int(v);
	      lm = TRUE;
	    }
	  else if (STRIEQN((char *)"R_MARGIN", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	      s = line.substr(8);
	      getright(s, v);
	      r_margin = get_int(v);
	      rm = TRUE;
	    }
	  else if (STRIEQN((char *)"T_MARGIN", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	      s = line.substr(8);
	      getright(s, v);
	      t_margin = get_int(v);
	      tm = TRUE;
	    }
	  else if (STRIEQN((char *)"B_MARGIN", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	      s = line.substr(8);
	      getright(s, v);
	      b_margin = get_int(v);
	      bm = TRUE;
	    }
	  else if (STRIEQN((char *)"FONTNAME", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	      s = line.substr(8);
	      getright(s, v);
	      fontname = v;
	      fn = TRUE;
	    }
	  else if (STRIEQN((char *)"FONTSIZE", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	      s = line.substr(8);
	      getright(s, v);
	      fontsize = get_int(v);
	      fs = TRUE;
	    }
	  else if (STRIEQN((char *)"FIXED", (char *)line.c_str(), 5) && IsSeparator(line[5]) )
	    {
	      s = line.substr(5);
	      getright(s, v);
	      fixed = ( (STRIEQ((char *)"TRUE", (char *)v.c_str())) || (STRIEQ((char *)"1", (char *)v.c_str())) );
	      fx = TRUE;
	    }
	  else if (STRIEQN((char *)"PREVIEW_COMMAND", (char *)line.c_str(), 15) && IsSeparator(line[15]) )
	    {
	      s = line.substr(15);
	      getright(s, v);
	      preview_command = v;
	      pv = TRUE;
	    }

// PRINTING COLOURS	
// Normal
	  else if (STRIEQN((char *)"N_P_RED", (char *)line.c_str(), 7) && IsSeparator(line[7]) )
	    {
	    s = line.substr(7);
	    getright(s, v);
	    n_p_red = string_to_double(v);
	    nr = TRUE;
	    }
	  else if (STRIEQN((char *)"N_P_GREEN", (char *)line.c_str(), 9) && IsSeparator(line[9]) )
	    {
	    s = line.substr(9);
	    getright(s, v);
	    n_p_green = string_to_double(v);
	    ng = TRUE;
	    }
	  else if (STRIEQN((char *)"N_P_BLUE", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	    s = line.substr(8);
	    getright(s, v);
	    n_p_blue = string_to_double(v);
	    nb = TRUE;
	    }

// Italic
	  else if (STRIEQN((char *)"I_P_RED", (char *)line.c_str(), 7) && IsSeparator(line[7]) )
	    {
	    s = line.substr(7);
	    getright(s, v);
	    i_p_red = string_to_double(v);
	    ir = TRUE;
	    }
	  else if (STRIEQN((char *)"I_P_GREEN", (char *)line.c_str(), 9) && IsSeparator(line[9]) )
	    {
	    s = line.substr(9);
	    getright(s, v);
	    i_p_green = string_to_double(v);
	    ig = TRUE;
	    }
	  else if (STRIEQN((char *)"I_P_BLUE", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	    s = line.substr(8);
	    getright(s, v);
	    i_p_blue = string_to_double(v);
	    ib = TRUE;
	    }

// Bold		
	  else if (STRIEQN((char *)"B_P_RED", (char *)line.c_str(), 7) && IsSeparator(line[7]) )
	    {
	    s = line.substr(7);
	    getright(s, v);
	    b_p_red = string_to_double(v);
	    br = TRUE;
	    }
	  else if (STRIEQN((char *)"B_P_GREEN", (char *)line.c_str(), 9) && IsSeparator(line[9]) )
	    {
	    s = line.substr(9);
	    getright(s, v);
	    b_p_green = string_to_double(v);
	    bg = TRUE;
	    }
	  else if (STRIEQN((char *)"B_P_BLUE", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	    s = line.substr(8);
	    getright(s, v);
	    b_p_blue = string_to_double(v);
	    bb = TRUE;
	    }

// Extra Bold		
	  else if (STRIEQN((char *)"EB_P_RED", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	    s = line.substr(8);
	    getright(s, v);
	    eb_p_red = string_to_double(v);
	    ebr = TRUE;
	    }
	  else if (STRIEQN((char *)"EB_P_GREEN", (char *)line.c_str(), 10) && IsSeparator(line[10]) )
	    {
	    s = line.substr(10);
	    getright(s, v);
	    eb_p_green = string_to_double(v);
	    ebg = TRUE;
	    }
	  else if (STRIEQN((char *)"EB_P_BLUE", (char *)line.c_str(), 9) && IsSeparator(line[9]) )
	    {
	    s = line.substr(9);
	    getright(s, v);
	    eb_p_blue = string_to_double(v);
	    ebb = TRUE;
	    }


// Error	
	  else if (STRIEQN((char *)"ER_P_RED", (char *)line.c_str(), 8) && IsSeparator(line[8]) )
	    {
	    s = line.substr(8);
	    getright(s, v);
	    er_p_red = string_to_double(v);
	    err = TRUE;
	    }
	  else if (STRIEQN((char *)"ER_P_GREEN", (char *)line.c_str(), 10) && IsSeparator(line[10]) )
	    {
	    s = line.substr(10);
	    getright(s, v);
	    er_p_green = string_to_double(v);
	    erg = TRUE;
	    }
	  else if (STRIEQN((char *)"ER_P_BLUE", (char *)line.c_str(), 9) && IsSeparator(line[9]) )
	    {
	    s = line.substr(9);
	    getright(s, v);
	    er_p_blue = string_to_double(v);
	    erb = TRUE;
	    }


		




		// WINDOW SIZES
	  else if (STRIEQN((char *)"MAIN_WINDOW_WIDTH", (char *)line.c_str(), 17) && IsSeparator(line[17]) )
	    {
	      s = line.substr(17);
	      getright(s, v);
	      main_window_width = get_int(v);
	      mww = TRUE;
	    }
	  else if (STRIEQN((char *)"MAIN_WINDOW_HEIGHT", (char *)line.c_str(), 18) && IsSeparator(line[18]) )
	    {
	      s = line.substr(18);
	      getright(s, v);
	      main_window_height = get_int(v);
	      mwh = TRUE;
	    }
	  else if (STRIEQN((char *)"MANPAGE_WIDTH", (char *)line.c_str(), 13) && IsSeparator(line[13]) )
	    {
	      s = line.substr(13);
	      getright(s, v);
	      manpage_width = get_int(v);
	      mpw = TRUE;
	    }
	  else if (STRIEQN((char *)"MANPAGE_HEIGHT", (char *)line.c_str(), 14) && IsSeparator(line[14]) )
	    {
	      s = line.substr(14);
	      getright(s, v);
	      manpage_height = get_int(v);
	      mph = TRUE;
	    }    
	  else if (STRIEQN((char *)"MANDIR_WIDTH", (char *)line.c_str(), 12) && IsSeparator(line[12]) )
	    {
	      s = line.substr(13);
	      getright(s, v);
	      mandir_width = get_int(v);
	      mdw = TRUE;
	    }
	  else if (STRIEQN((char *)"MANDIR_HEIGHT", (char *)line.c_str(), 13) && IsSeparator(line[13]) )
	    {
	      s = line.substr(14);
	      getright(s, v);
	      mandir_height = get_int(v);
	      mdh = TRUE;
	    }
	  else if (STRIEQN((char *)"EDIT_WIDTH", (char *)line.c_str(), 10) && IsSeparator(line[10]) )
	    {
	      s = line.substr(10);
	      getright(s, v);
	      edit_width = get_int(v);
	      ew = TRUE;
	    }
	  else if (STRIEQN((char *)"EDIT_HEIGHT", (char *)line.c_str(), 11) && IsSeparator(line[11]) )
	    {
	      s = line.substr(11);
	      getright(s, v);
	      edit_height = get_int(v);
	      eh = TRUE;
	    }
	  else if (STRIEQN((char *)"APROPOS_WIDTH", (char *)line.c_str(), 13) && IsSeparator(line[13]) )
	    {
	      s = line.substr(13);
	      getright(s, v);
	      apropos_width = get_int(v);
	      apw = TRUE;
	    }
	  else if (STRIEQN((char *)"APROPOS_HEIGHT", (char *)line.c_str(), 14) && IsSeparator(line[14]) )
	    {
	      s = line.substr(14);
	      getright(s, v);
	      apropos_height = get_int(v);
	      aph = TRUE;
	    }
	  else if (STRIEQN((char *)"PRINTPREFS_WIDTH", (char *)line.c_str(), 16) && IsSeparator(line[16]) )
	    {
	      s = line.substr(16);
	      getright(s, v);
	      printprefs_width = get_int(v);
	      ppw = TRUE;
	    }
	  else if (STRIEQN((char *)"PRINTPREFS_HEIGHT", (char *)line.c_str(), 17) && IsSeparator(line[17]) )
	    {
	      s = line.substr(17);
	      getright(s, v);
	      printprefs_height = get_int(v);
	      pph = TRUE;
	    }
	  else if (STRIEQN((char *)"DISPLAYPREFS_WIDTH", (char *)line.c_str(), 18) && IsSeparator(line[18]) )
	    {
	      s = line.substr(18);
	      getright(s, v);
	      displayprefs_width = get_int(v);
	      dpw = TRUE;
	    }
	  else if (STRIEQN((char *)"DISPLAYPREFS_HEIGHT", (char *)line.c_str(), 19) && IsSeparator(line[19]) )
	    {
	      s = line.substr(19);
	      getright(s, v);
	      displayprefs_height = get_int(v);
	      dph = TRUE;
	    }
	  else if (STRIEQN((char *)"EDITPREFS_WIDTH", (char *)line.c_str(), 15) && IsSeparator(line[16]) )
	    {
	    s = line.substr(15);
	    getright(s, v);
	    editprefs_width = get_int(v);
	    epw = TRUE;
	    }
	  else if (STRIEQN((char *)"EDITPREFS_HEIGHT", (char *)line.c_str(), 16) && IsSeparator(line[16]) )
	    {
	    s = line.substr(16);
	    getright(s, v);
	    editprefs_height = get_int(v);
	    eph = TRUE;
	    }
	  else if (STRIEQN((char *)"ABOUT_WIDTH", (char *)line.c_str(), 11) && IsSeparator(line[11]) )
	    {
	      s = line.substr(11);
	      getright(s, v);
	      about_width = get_int(v);
	      aw = TRUE;
	    }
	  else if (STRIEQN((char *)"ABOUT_HEIGHT", (char *)line.c_str(), 12) && IsSeparator(line[12]) )
	    {
	      s = line.substr(12);
	      getright(s, v);
	      about_height = get_int(v);
	      ah = TRUE;
	    }

    // EDITOR AUTOSAVE
	  else if (STRIEQN((char *)"AUTOSAVE_SECONDS", (char *)line.c_str(), 16) && IsSeparator(line[16]) )
	    {
	      s = line.substr(16);
	      getright(s, v);
	      autosave_seconds = get_int(v);
	      ass = TRUE;
	    }
	  else if (STRIEQN((char *)"AUTOSAVE_CHANGES", (char *)line.c_str(), 16) && IsSeparator(line[16]) )
	    {
	      s = line.substr(16);
	      getright(s, v);
	      autosave_changes = get_int(v);
	      asc = TRUE;
	    }


    
    // ERROR
    else
	    {
	      // BAD INPUT, skip
	    }
	}

      ifp.close();
    }

  // Load defaults as required
  if (!pn) printername =d_printername;
  if (!sz) papersize.size = d_papersize.size;
  if (!wd) papersize.width = d_papersize.width;
  if (!ht) papersize.height = d_papersize.height;
  if (!lm) l_margin = d_l_margin;
  if (!rm) r_margin = d_r_margin;
  if (!tm) t_margin = d_t_margin;
  if (!bm) b_margin = d_b_margin;
  if (!fn) fontname = d_fontname;
  if (!fs) fontsize = d_fontsize;
  if (!fx) fixed = d_fixed;
  if (!pv) preview_command = d_preview_command;

	/*
  if (!nc)  n_pcolour  = d_n_pcolour;
  if (!ic)  i_pcolour  = d_i_pcolour;
  if (!bc)  b_pcolour  = d_b_pcolour;
  if (!ebc) eb_pcolour = d_eb_pcolour;
  if (!erc) er_pcolour = d_er_pcolour;
	*/

if (!nr) n_p_red = d_n_p_red;
if (!ng) n_p_green = d_n_p_green;
if (!nb) n_p_blue = d_n_p_blue;


if (!ir) i_p_red = d_i_p_red;
if (!ig) i_p_green = d_i_p_green;
if (!ib) i_p_blue = d_i_p_blue;



if (!br) b_p_red = d_b_p_red;
if (!bg) b_p_green = d_b_p_green;
if (!bb) b_p_blue = d_b_p_blue;


if (!ebr) eb_p_red = d_eb_p_red;
if (!ebg) eb_p_green = d_eb_p_green;
if (!ebb) eb_p_blue = d_eb_p_blue;


if (!err) er_p_red = d_er_p_red;
if (!erg) er_p_green = d_er_p_green;
if (!erb) er_p_blue = d_er_p_blue;










	
  if(!mww) main_window_width   = d_main_window_width;
  if(!mwh) main_window_height  = d_main_window_height;
  if(!mdw) mandir_width        = d_mandir_width;
  if(!mdh) mandir_height       = d_mandir_height;
  if(!mpw) manpage_width       = d_manpage_width;
  if(!mph) manpage_height      = d_manpage_height;
  if(!ew)  edit_width          = d_edit_width;
  if(!eh)  edit_height         = d_edit_height;
  if(!apw) apropos_width       = d_apropos_width;
  if(!aph) apropos_height      = d_apropos_height;
  if(!ppw) printprefs_width    = d_printprefs_width;
  if(!pph) printprefs_height   = d_printprefs_height;
  if(!dpw) displayprefs_width  = d_displayprefs_width;
  if(!dph) displayprefs_height = d_displayprefs_height;
  if(!epw) editprefs_width     = d_editprefs_width;
  if(!eph) editprefs_height    = d_editprefs_height;  
  if(!aw)  about_width         = d_about_width;
  if(!ah)  about_height        = d_about_height;

  if(!ass) autosave_seconds    = d_autosave_seconds;
  if(!asc) autosave_changes    = d_autosave_changes;
}

// Save preferences
void Prefs::save(void)
{
  fstream ofp;

  // Overwrite any existing file
  ofp.open(pathname.c_str(), ios::out | ios::binary | ios::trunc );

  if ( ofp.is_open() )
    {
      string v;

      ofp << "PRINTERNAME = " << printername << endl;
      ofp << "SIZE = " << papersize.size << endl;
      ofp << "WIDTH = " << papersize.width << endl;
      ofp << "HEIGHT = " << papersize.height << endl;
      ofp << "L_MARGIN = " << l_margin << endl;
      ofp << "R_MARGIN = " << r_margin << endl;
      ofp << "T_MARGIN = " << t_margin << endl;
      ofp << "B_MARGIN = " << b_margin << endl;
      ofp << "FONTNAME = " << fontname << endl;
      ofp << "FONTSIZE = " << fontsize << endl;
      ofp << "FIXED = " << (char *)((fixed) ? "TRUE" : "FALSE") << endl;
      ofp << "PREVIEW_COMMAND = \"" << preview_command << "\"" << endl;

      // Try saving these in hex format
/*
      i2hex(n_pcolour, v, TRUE);
      ofp << "N_PCOLOUR = " << v << endl;
      i2hex(i_pcolour, v, TRUE);
      ofp << "I_PCOLOUR = " << v << endl;
      i2hex(b_pcolour, v, TRUE);
      ofp << "B_PCOLOUR = " << v << endl;
      i2hex(eb_pcolour, v, TRUE);
      ofp << "EB_PCOLOUR = " << v << endl;
      i2hex(er_pcolour, v, TRUE);
      ofp << "ER_PCOLOUR = " << v << endl;
*/

// PRINTING COLOURS	
// Normal
		ofp << "N_P_RED = "	<< n_p_red << endl;
		ofp << "N_P_GREEN = "	<< n_p_green << endl;
		ofp << "N_P_BLUE = "	<< n_p_blue << endl;

// Italic
		ofp << "I_P_RED = "	<< i_p_red << endl;
		ofp << "I_P_GREEN = "	<< i_p_green << endl;
		ofp << "I_P_BLUE = "	<< i_p_blue << endl;

// Bold	
		ofp << "B_P_RED = "	<< b_p_red << endl;
		ofp << "B_P_GREEN = "	<< b_p_green << endl;
		ofp << "B_P_BLUE = "	<< b_p_blue << endl;

// Extra Bold
		ofp << "EB_P_RED = "	<< eb_p_red << endl;
		ofp << "EB_P_GREEN = "	<< eb_p_green << endl;
		ofp << "EB_P_BLUE = "	<< eb_p_blue << endl;

// Error	
		ofp << "ER_P_RED = "	<< er_p_red << endl;
		ofp << "ER_P_GREEN = "	<< er_p_green << endl;
		ofp << "ER_P_BLUE = "	<< er_p_blue << endl;


// WINDOW SIZES			
      ofp << "MAIN_WINDOW_WIDTH   = " << main_window_width  << endl;
      ofp << "MAIN_WINDOW_HEIGHT  = " << main_window_height << endl;
      ofp << "MANPAGE_WIDTH       = " << manpage_width  << endl;
      ofp << "MANPAGE_HEIGHT      = " << manpage_height << endl;
      ofp << "MANDIR_WIDTH        = " << mandir_width  << endl;
      ofp << "MANDIR_HEIGHT       = " << mandir_height << endl;      
      ofp << "EDIT_WIDTH          = " << edit_width  << endl;
      ofp << "EDIT_HEIGHT         = " << edit_height << endl;
      ofp << "APROPOS_WIDTH       = " << apropos_width  << endl;
      ofp << "APROPOS_HEIGHT      = " << apropos_height << endl;
      ofp << "PRINTPREFS_WIDTH    = " << printprefs_width  << endl;
      ofp << "PRINTPREFS_HEIGHT   = " << printprefs_height << endl;
      ofp << "DISPLAYPREFS_WIDTH  = " << displayprefs_width  << endl;
      ofp << "DISPLAYPREFS_HEIGHT = " << displayprefs_height << endl;
      ofp << "EDITPREFS_WIDTH     = " << editprefs_width  << endl;
      ofp << "EDITPREFS_HEIGHT    = " << editprefs_height << endl;
      ofp << "ABOUT_WIDTH         = " << about_width  << endl;
      ofp << "ABOUT_HEIGHT        = " << about_height << endl;

      ofp << "AUTOSAVE_SECONDS    = " << autosave_seconds << endl;
      ofp << "AUTOSAVE_CHANGES    = " << autosave_changes << endl;

      ofp.close();
    }
}
