/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       printfile.cpp                                             *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       13-Mar-2013 13.57.37 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Print module                                                              *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#include <sys/types.h>
#include <pwd.h>

#include "printfile.h"
#include "manpage.h"
#include "tfile.h"
#include "misc.h"

using namespace misc;


const char *test_str =
"Special Characters\n"
  "Eth:       \xc3\x90""abcde\n"
  "abcdefghijklmnopqrstuvwxyz\n"
  "eth:       \xc3\xb0\n"
  "Thorn:     \xc3\x9e\n"
  "thorn:     \xc3\xbe\n"
  "germandbls:\xc3\x9f\n"

  "\nLigatures\n"

  "ff:        \xef\xac\x80""abcde\n"  // Expert character set, can't load it so create char
  "abcdefghijklmnopqrstuvwxyz\n"
  "fi:        \xef\xac\x81""abcde\n"
  "abcdefghijklmnopqrstuvwxyz\n"
  "fl:        \xef\xac\x82""abcde\n"
  "abcdefghijklmnopqrstuvwxyz\n"
  "ffi:       \xef\xac\x83""abcde\n"  // Expert character set, can't load it so create char
  "abcdefghijklmnopqrstuvwxyz\n"
  "ffl:       \xef\xac\x84""abcde\n"  // Expert character set, can't load it so create char
  "abcdefghijklmnopqrstuvwxyz\n"
  "AE:        \xc3\x86""abcde\n"
  "abcdefghijklmnopqrstuvwxyz\n"
  "ae:        \xc3\xa6""abcde\n"
  "abcdefghijklmnopqrstuvwxyz\n"
  "OE:        \xc5\x92""abcde\n"
  "abcdefghijklmnopqrstuvwxyz\n"
  "oe:        \xc5\x93""abcde\n"
  "abcdefghijklmnopqrstuvwxyz\n"
  "dotlessi:  \xc4\xb1""abcde\n"

  "\nAccented Characters\n"

  "Aacute:    \xc3\x81\n"
  "Eacute:    \xc3\x89\n"
  "Iacute:    \xc3\x8d\n"
  "Oacute:    \xc3\x93\n"
  "Yacute:    \xc3\x9d\n"
  "aacute:    \xc3\xa1\n"
  "eacute:    \xc3\xa9\n"
  "iacute:    \xc3\xad\n"
  "oacute:    \xc3\xb3\n"
  "yacute:    \xc3\xbd\n"
  "Adieresis: \xc3\x84\n"
  "Edieresis: \xc3\x8b\n"
  "Idieresis: \xc3\x8f\n"
  "Odieresis: \xc3\x96\n"
  "Udieresis: \xc3\x9c\n"
  "Ydieresis: \xc5\xb8\n"
  "adieresis: \xc3\xa4\n"
  "edieresis: \xc3\xab\n"
  "idieresis: \xc3\xaf\n"
  "odieresis: \xc3\xb6\n"
  "udieresis: \xc3\xbc\n"
  "ydieresis: \xc3\xbf\n"
  "Acircumflex:\xc3\x82\n"
  "Ecircumflex:\xc3\x8a\n"
  "Icircumflex:\xc3\x8e\n"
  "Ocircumflex:\xc3\x94\n"
  "Ucircumflex:\xc3\x9b\n"
  "acircumflex:\xc3\xa2\n"
  "ecircumflex:\xc3\xaa\n"
  "icircumflex:\xc3\xae\n"
  "ocircumflex:\xc3\xb4\n"
  "ucircumflex:\xc3\xbb\n"
  "Agrave:    \xc3\x80\n"
  "Egrave:    \xc3\x88\n"
  "Igrave:    \xc3\x8c\n"
  "Ograve:    \xc3\x92\n"
  "Ugrave:    \xc3\x99\n"
  "agrave:    \xc3\xa0\n"
  "egrave:    \xc3\xa8\n"
  "igrave:    \xc3\xac\n"
  "ograve:    \xc3\xb2\n"
  "ugrave:    \xc3\xb9\n"
  "Atilde:    \xc3\x83\n"
  "Ntilde:    \xc3\x91\n"
  "Otilde:    \xc3\x95\n"
  "atilde:    \xc3\xa3\n"
  "ntilde:    \xc3\xb1\n"
  "otilde:    \xc3\xb5\n"
  "Scaron:    \xc5\xa0\n"
  "scaron:    \xc5\xa1\n"
  "Zcaron:    \xc5\xbd\n"
  "zcaron:    \xc5\xbe\n"
  "Ccedilla:  \xc3\x87\n"
  "ccedilla:  \xc3\xa7\n"
  "Lslash:    \xc5\x81\n"
  "lslash:    \xc5\x82\n"
  "Oslash:    \xc3\x98\n"
  "oslash:    \xc3\xb8\n"
  "Aring:     \xc3\x85\n"
  "aring:     \xc3\xa5\n"

  "\nAccents\n"
  "hungarumlaut: \xcb\x9d\n"
  "macro:        \xc2\xaf\n"
  "dotaccent:    \xcb\x99\n"
  "acute:        \xc2\xb4\n"
  "breve:        \xcb\x98\n"
  "cedilla:      \xc2\xb8\n"
  "dieresis:     \xc2\xa8\n"
  "caron:        \xcb\x87\n"
  "ring:         \xcb\x9a\n"
  "ogonek:       \xcb\x9b\n"
  "asciitilde:   \xe2\x88\xbc\n"

  "\nQuotes\n"
  "quotedblbase:   \xe2\x80\x9e\n"
  "quotesinglbase: \xe2\x80\x9a\n"
  "quotedblleft:   \xe2\x80\x9c\n"
  "quotedblright:  \xe2\x80\x9d\n"
  "quoteleft:      \xe2\x80\x98\n"
  "quoteright:     \xe2\x80\x99\n"
  "guillemotleft:  \xc2\xab\n"
  "guillemotright: \xc2\xbb\n"
  "guilsinglleft   \xe2\x80\xb9\n"
  "guilsinglright: \xe2\x80\xba\n"

  "\nPunctuation\n"
  "exclamdown:     \xc2\xa1\n"
  "questiondown:   \xc2\xbf\n"
  "emdash:         \xe2\x80\x94\n"
  "endash:         \xe2\x80\x93\n"
  "hyphen:         \xe2\x80\x90\n"

  "\nBrackets\n"
  "angleleft:      \xe2\x8c\xa9\n"
  "angleright:     \xe2\x8c\xaa\n"

  "\nArrows\n"
  "arrowleft:      \xe2\x86\x90\n"
  "arrowright:     \xe2\x86\x92\n"
  "arrowboth:      \xe2\x86\x94\n"
  "arrowdown:      \xe2\x86\x93\n"
  "arrowup:        \xe2\x86\x91\n"
  "arrowdblleft:   \xe2\x87\x90\n"
  "arrowdblright:  \xe2\x87\x92\n"
  "arrowdblboth:   \xe2\x87\x94\n"
  "arrowdbldown:   \xe2\x87\x93\n"
  "arrowdblup:     \xe2\x87\x91\n"
  "arrowhorizex:   \xe2\x94\x80\n"

  "\nLines\n"
  "arrowvertex:    \xe2\x94\x82\n"  // should be br or bv, a tall bar, NOT bar!
  "brokenbar:      \xc2\xa6\n"

  "\nText markers\n"
  "circle:         \xe2\x97\xaf\n"
  "bullet:         \xc2\xb7\n"
  "daggerdbl:      \xe2\x80\xa1\n"
  "dagger:         \xe2\x80\xa0\n"
  "lozenge:        \xe2\x97\x8a\n"
  "square:         \xe2\x96\xa1\n"
  "paragraph:      \xc2\xb6\n"
  "section:        \xc2\xa7\n"
  "handleft:       \xe2\x98\x9c\n"
  "handright:      \xe2\x98\x9e\n"
  "carriagereturn: \xe2\x90\x8d\n"

  "\nLegal\n"
  "copyright:  \xc2\xa9\n"
  "registered: \xc2\xae\n"
  "trademark:  \xe2\x84\xa2\n\n"
  "Currency Symbols\n"
  "cent:       \xc2\xa2\n"
  "Euro:       \xe2\x82\xac\n"
  "yen:        \xc2\xa5\n"
  "sterling:   \xc2\xa3\n"
  "currency:   \xc2\xa4\n"
  "florin:     \xc6\x92\n"

  "\nUnits\n"
  "degree:       \xc2\xb0\n"
  "perthousand:  \xe2\x80\xb0\n"
  "minute:       \xe2\x80\xb2\n"
  "second:       \xe2\x80\xb3\n"
  "mu:           \xc2\xb5\n"
  "ordfeminine:  \xc2\xaa\n"
  "ordmasculine: \xc2\xba\n"

  "\nLogical Symbols\n"
  "logicaland:   \xe2\x88\xa7\n"
  "logicalor:    \xe2\x88\xa8\n"
  "logicalnot:   \xc2\xac\n"
  "existential:  \xe2\x88\x83\n"
  "universal:    \xe2\x88\x80\n"
  "suchthat:     \xe2\x88\x8b\n"
  "therefore:    \xe2\x88\xb4\n"

  "\nMaths Symbols\n"
  "onehalf:         \xc2\xbd\n"
  "onequarter:      \xc2\xbc\n"
  "threequarters:   \xc2\xbe\n"
  "onesuperior:     \xc2\xb9\n"
  "twosuperior:     \xc2\xb2\n"
  "threesuperior:   \xc2\xb3\n"
  "minus:           \xe2\x88\x92\n"
  "plusminus:       \xc2\xb1\n"
  "dotmath:         \xe2\x8b\x85\n"
  "multiply:        \xc3\x97\n"
  "circlemultiply:  \xe2\x8a\x97\n"
  "circleplus:      \xe2\x8a\x95\n"
  "divide:          \xc3\xb7\n"
  "fraction:        \xe2\x81\x84\n"
  "asteriskmath:    \xe2\x88\x97\n"
  "lessequal:       \xe2\x89\xa4\n"
  "greaterequal:    \xe2\x89\xa5\n"
  "notequal:        \xe2\x89\xa0\n"
  "equivalence:     \xe2\x89\xa1\n"
  "congruent:       \xe2\x89\x85\n"
  "approxequal:     \xe2\x89\x88\n"
  "proportional:    \xe2\x88\x9d\n"
  "emptyset:        \xe2\x88\x85\n"
  "element:         \xe2\x88\x88\n"
  "notelement:      \xe2\x88\x89\n"
  "notsubset:       \xe2\x8a\x84\n"
  "propersubset:    \xe2\x8a\x82\n"
  "propersuperset:  \xe2\x8a\x83\n"
  "reflexsubset:    \xe2\x8a\x86\n"
  "reflexsuperset:  \xe2\x8a\x87\n"
  "intersection:    \xe2\x88\xa9\n"
  "union: (or cup): \xe2\x88\xaa\n"
  "angle:           \xe2\x88\xa0\n"
  "perpendicular:   \xe2\x8a\xa5\n"
  "integral:        \xe2\x88\xab\n"
  "summation:       \xe2\x88\x91\n"
  "product:         \xe2\x88\x8f\n"
  "gradient:        \xe2\x88\x87\n"
  "radical:         \xe2\x88\x9a\n"
  "radicalex:       \xe2\x80\xbe\n"
  "infinity:        \xe2\x88\x9e\n"
  "aleph:           \xe2\x84\xb5\n"
  "Ifractur:        \xe2\x84\x91\n"
  "Rfractur:        \xe2\x84\x9c\n"
  "weierstrass:     \xe2\x84\x98\n"
  "partialdiff:     \xe2\x88\x82\n"

  "\nGreek Characters\n"
  "Alpha:    \xce\x91\n"
  "Beta:     \xce\x92\n"
  "Xi:       \xce\x9e\n"
  "Delta:    \xce\x94\n"
  "Epsilon:  \xce\x95\n"
  "Phi:      \xce\xa6\n"
  "Gamma:    \xce\x93\n"
  "Theta:    \xce\x98\n"
  "Iota:     \xce\x99\n"
  "Kappa:    \xce\x9a\n"
  "Lambda:   \xce\x9b\n"
  "Mu:       \xce\x9c\n"
  "Nu:       \xce\x9d\n"
  "Omicron:  \xce\x9f\n"
  "Pi:       \xce\xa0\n"
  "Psi:      \xce\xa8\n"
  "Rho:      \xce\xa1\n"
  "Sigma:    \xce\xa3\n"
  "Tau:      \xce\xa4\n"
  "Upsilon:  \xce\xa5\n"
  "Omega:    \xce\xa9\n"
  "Chi:      \xce\xa7\n"
  "Eta:      \xce\x97\n"
  "Zeta:     \xce\x96\n"
  "alpha:   \xce\xb1\n"
  "beta:    \xce\xb2\n"
  "xi:      \xce\xbe\n"
  "delta:   \xce\xb4\n"
  "epsilon: \xce\xb5\n"
  "phi:     \xcf\x86\n"
  "phi1:    \xcf\x95\n"
  "gamma:   \xce\xb3\n"
  "theta:   \xce\xb8\n"
  "theta1:  \xcf\x91\n"
  "iota:    \xce\xb9\n"
  "kappa:   \xce\xba\n"
  "lambda:  \xce\xbb\n"
  "mu:      \xce\xbc\n"
  "nu:      \xce\xbd\n"
  "omicron: \xce\xbf\n"
  "pi:      \xcf\x80\n"
  "omega1:  \xcf\x96\n"
  "psi:     \xcf\x88\n"
  "rho:     \xcf\x81\n"
  "sigma:   \xcf\x83\n"
  "tau:     \xcf\x84\n"
  "upsilon: \xcf\x85\n"
  "omega:   \xcf\x89\n"
  "chi:     \xcf\x87\n"
  "eta:     \xce\xb7\n"
  "zeta:    \xce\xb6\n"
  "sigma1:  \xcf\x82\n"

  "\nPlaying Cards\n"
  "club:    \xe2\x99\xa3\n"
  "spade:   \xe2\x99\xa0\n"
  "heart:   \xe2\x99\xa5\n"
  "diamond: \xe2\x99\xa6\n";





Printfile::Printfile(class ManPage *manpage)
{
  cout << "Printfile:\n";

  mp = manpage;
  gman = mp->gman;

  p = (char *)mp->filebuffer.c_str();
  end = p + mp->fblen;

  //p = test_str;
  //end = test_str + strlen(test_str);

  do_printfile(FALSE);  // Not preview
}

Printfile::Printfile(class ManPage *manpage, string &fname)
{
  cout << "~Printfile:\n";

  mp = manpage;
  gman = mp->gman;

  p = (char *)mp->filebuffer.c_str();
  end = p + mp->fblen;

  //p = test_str;
  //end = test_str + strlen(test_str);

  do_printfile(TRUE);  // Preview
  fname = tname;       // fills in fname for ManPage::callback_printpreview
}




Printfile::~Printfile(void)
{
  cout << "~Printfile:\n";
}



struct charentry
{
  char code[4];
  unsigned short ucs; // Get rid of this field - not used
  char font;          // "S" if a symbol i.e. requires Symbol font, 'E' for expert
  const char *charname;

}
chartable[] =
  {

  // Special Characters
  //====================
    { {'\xc3', '\x90', 0,     0},  0x00D0, 0,  "Eth" },
    { {'\xc3', '\xb0', 0,     0},  0x00F0, 0,  "eth" }, 
    { {'\xc3', '\x9e', 0,     0},  0x00FE, 0,  "Thorn" },
    { {'\xc3', '\xbe', 0,     0},  0x00FE, 0,  "thorn" },
    { {'\xc3', '\x9f', 0,     0},  0x00DF, 0,  "germandbls" }, // Capital, not small

  // Ligatures
  //===========
    { {'\xef', '\xac', '\x80', 0}, 0x0000, 'L', "ff"  },
    { {'\xef', '\xac', '\x81', 0}, 0xFB01, 0, "fi"  },
    { {'\xef', '\xac', '\x82', 0}, 0xFB02, 0, "fl"  },
    { {'\xef', '\xac', '\x83', 0}, 0x0000, 'L', "ffi" },
    { {'\xef', '\xac', '\x84', 0}, 0x0000, 'L', "ffl" },

    { {'\xc3', '\x86', 0,      0}, 0x00C6, 0, "AE"  },
    { {'\xc3', '\xa6', 0,      0}, 0x00E6, 0, "ae"  },
    { {'\xc5', '\x92', 0,      0}, 0x0152, 0, "OE"  },
    { {'\xc5', '\x93', 0,      0}, 0x0153, 0, "oe"  },
    { {'\xc4', '\xb1', 0,      0}, 0x0131, 0, "dotlessi" }, // Turkish i without a dot

  // Accented Characters
  //=====================
    { {'\xc3', '\x81', 0,      0}, 0x00C1, 0, "Aacute" },
    { {'\xc3', '\x89', 0,      0}, 0x00C9, 0, "Eacute" },
    { {'\xc3', '\x8d', 0,      0}, 0x00CD, 0, "Iacute" },
    { {'\xc3', '\x93', 0,      0}, 0x00D3, 0, "Oacute" },
    { {'\xc3', '\x9a', 0,      0}, 0x00DA, 0, "Uacute" },
    { {'\xc3', '\x9d', 0,      0}, 0x00DD, 0, "Yacute" },
    { {'\xc3', '\xa1', 0,      0}, 0x00E1, 0, "aacute" },
    { {'\xc3', '\xa9', 0,      0}, 0x00E9, 0, "eacute" },
    { {'\xc3', '\xad', 0,      0}, 0x00ED, 0, "iacute" },
    { {'\xc3', '\xb3', 0,      0}, 0x00F3, 0, "oacute" },
    { {'\xc3', '\xba', 0,      0}, 0x00FA, 0, "uacute" },
    { {'\xc3', '\xbd', 0,      0}, 0x00FD, 0, "yacute" },
    { {'\xc3', '\x84', 0,      0}, 0x00C4, 0, "Adieresis" }, // A with umlaut
    { {'\xc3', '\x8b', 0,      0}, 0x00CB, 0, "Edieresis" },
    { {'\xc3', '\x8f', 0,      0}, 0x00CF, 0, "Idieresis" },
    { {'\xc3', '\x96', 0,      0}, 0x00D6, 0, "Odieresis" },
    { {'\xc3', '\x9c', 0,      0}, 0x00DC, 0, "Udieresis" },
    { {'\xc5', '\xb8', 0,      0}, 0x0178, 0, "Ydieresis" },
    { {'\xc3', '\xa4', 0,      0}, 0x00E4, 0, "adieresis" },
    { {'\xc3', '\xab', 0,      0}, 0x00EB, 0, "edieresis" },
    { {'\xc3', '\xaf', 0,      0}, 0x00EF, 0, "idieresis" },
    { {'\xc3', '\xb6', 0,      0}, 0x00F6, 0, "odieresis" },
    { {'\xc3', '\xbc', 0,      0}, 0x00FC, 0, "udieresis" },
    { {'\xc3', '\xbf', 0,      0}, 0x00FF, 0, "ydieresis" },
    { {'\xc3', '\x82', 0,      0}, 0x00C2, 0, "Acircumflex" },
    { {'\xc3', '\x8a', 0,      0}, 0x00CA, 0, "Ecircumflex" },
    { {'\xc3', '\x8e', 0,      0}, 0x00CE, 0, "Icircumflex" },
    { {'\xc3', '\x94', 0,      0}, 0x00D4, 0, "Ocircumflex" },
    { {'\xc3', '\x9b', 0,      0}, 0x00DB, 0, "Ucircumflex" },
    { {'\xc3', '\xa2', 0,      0}, 0x00E2, 0, "acircumflex" },
    { {'\xc3', '\xaa', 0,      0}, 0x00EA, 0, "ecircumflex" },
    { {'\xc3', '\xae', 0,      0}, 0x00EE, 0, "icircumflex" },
    { {'\xc3', '\xb4', 0,      0}, 0x00F4, 0, "ocircumflex" },
    { {'\xc3', '\xbb', 0,      0}, 0x00FB, 0, "ucircumflex" },
    { {'\xc3', '\x80', 0,      0}, 0x00C0, 0, "Agrave" },
    { {'\xc3', '\x88', 0,      0}, 0x00C8, 0, "Egrave" },
    { {'\xc3', '\x8c', 0,      0}, 0x00CC, 0, "Igrave" },
    { {'\xc3', '\x92', 0,      0}, 0x00D2, 0, "Ograve" },
    { {'\xc3', '\x99', 0,      0}, 0x00D9, 0, "Ugrave" },
    { {'\xc3', '\xa0', 0,      0}, 0x00E0, 0, "agrave" },
    { {'\xc3', '\xa8', 0,      0}, 0x00E8, 0, "egrave" },
    { {'\xc3', '\xac', 0,      0}, 0x00EC, 0, "igrave" },
    { {'\xc3', '\xb2', 0,      0}, 0x00F2, 0, "ograve" },
    { {'\xc3', '\xb9', 0,      0}, 0x00F9, 0, "ugrave" },
    { {'\xc3', '\x83', 0,      0}, 0x00C3, 0, "Atilde" },
    { {'\xc3', '\x91', 0,      0}, 0x00D1, 0, "Ntilde" },
    { {'\xc3', '\x95', 0,      0}, 0x00D5, 0, "Otilde" },
    { {'\xc3', '\xa3', 0,      0}, 0x00E3, 0, "atilde" },
    { {'\xc3', '\xb1', 0,      0}, 0x00D1, 0, "ntilde" },
    { {'\xc3', '\xb5', 0,      0}, 0x00F5, 0, "otilde" },
    { {'\xc5', '\xa0', 0,      0}, 0x0160, 0, "Scaron" },
    { {'\xc5', '\xa1', 0,      0}, 0x0161, 0, "scaron" },
    { {'\xc5', '\xbd', 0,      0}, 0x017D, 0, "Zcaron" },
    { {'\xc5', '\xbe', 0,      0}, 0x017E, 0, "zcaron" },
    { {'\xc3', '\x87', 0,      0}, 0x00C7, 0, "Ccedilla" },
    { {'\xc3', '\xa7', 0,      0}, 0x00E7, 0, "ccedilla" },
    { {'\xc5', '\x81', 0,      0}, 0x0141, 0, "Lslash" }, // Polish L with a slash
    { {'\xc5', '\x82', 0,      0}, 0x0142, 0, "lslash" }, // Polish l with a slash
    { {'\xc3', '\x98', 0,      0}, 0x00D8, 0, "Oslash" }, // Scandinavic slashed O
    { {'\xc3', '\xb8', 0,      0}, 0x00F8, 0, "oslash" }, // Scandinavic slashed o
    { {'\xc3', '\x85', 0,      0}, 0x00C5, 0, "Aring" },
    { {'\xc3', '\xa5', 0,      0}, 0x00E5, 0, "aring" },

  // Accents
  //=========
    { {'\xcb', '\x9d', 0,      0}, 0x02DD, 0, "hungarumlaut" }, // Hungarian umlaut
    { {'\xc2', '\xaf', 0,      0}, 0x02C9, 0, "macron" },       // macron or bar accent
    { {'\xcb', '\x99', 0,      0}, 0x02D9, 0, "dotaccent" },
// circumflex
    { {'\xc2', '\xb4', 0,      0}, 0x00B4, 0, "acute" },
// grave
    { {'\xcb', '\x98', 0,      0}, 0x02D8, 0, "breve" },
    { {'\xc2', '\xb8', 0,      0}, 0x00B8, 0, "cedilla" },
    { {'\xc2', '\xa8', 0,      0}, 0x00A8, 0, "dieresis" },     // umlaut or dieresis
    { {'\xcb', '\x87', 0,      0}, 0x02C7, 0, "caron" },        // like an upsidedown circumflex
    { {'\xcb', '\x9a', 0,      0}, 0x02DA, 0, "ring" },
// tilde                                   // small tilde accent
    { {'\xcb', '\x9b', 0,      0}, 0x02DB, 0, "ogonek" },       // hook or ogonek accent
// asciicircum                                                  // ASCII circumflex, hat, caret
    { {'\xe2', '\x88', '\xbc', 0}, 0x0000, 0, "asciitilde" },   // Large tilde
  // Quotes
  //========
    { {'\xe2', '\x80', '\x9e', 0}, 0x201E, 0, "quotedblbase" },   // low double comma quote
    { {'\xe2', '\x80', '\x9a', 0}, 0x201A, 0, "quotesinglbase" }, // low single comma quote
    { {'\xe2', '\x80', '\x9c', 0}, 0x0000, 0, "quotedblleft" },
    { {'\xe2', '\x80', '\x9d', 0}, 0x0000, 0, "quotedblright" },
    { {'\xe2', '\x80', '\x98', 0}, 0x2018, 0, "quoteleft" },
    { {'\xe2', '\x80', '\x99', 0}, 0x2019, 0, "quoteright" },
// quotesingle                                        // apostrophe quote
// quotedbl                                           // double quote (ASCII 34)
    { {'\xc2', '\xab', 0,      0}, 0x00AB, 0, "guillemotleft" },
    { {'\xc2', '\xbb', 0,      0}, 0x00BB, 0, "guillemotright" },
    { {'\xe2', '\x80', '\xb9', 0}, 0x2039, 0, "guilsinglleft" },
    { {'\xe2', '\x80', '\xba', 0}, 0x203A, 0, "guilsinglright" },

  // Punctuation 
  //=============
    { {'\xc2', '\xa1', 0,      0}, 0x00A1, 0, "exclamdown" },
    { {'\xc2', '\xbf', 0,      0}, 0x00BF, 0, "questiondown" },
    { {'\xe2', '\x80', '\x94', 0}, 0x2015, 0, "emdash" },
    { {'\xe2', '\x80', '\x93', 0}, 0x2013, 0, "endash" },
    { {'\xe2', '\x80', '\x90', 0}, 0x2010, 0, "hyphen" },  // Should be a short hyphen, actually same as ASCII hyphen

  // Brackets
  //==========
// bracketleft
// bracketright
// braceleft
// braceright
    { {'\xe2', '\x8c', '\xa9', 0}, 0x0000, 'S', "angleleft" },
    { {'\xe2', '\x8c', '\xaa', 0}, 0x0000, 'S', "angleright" },

  // Arrows
  //========
    { {'\xe2', '\x86', '\x90', 0}, 0x0000, 'S', "arrowleft" },
    { {'\xe2', '\x86', '\x92', 0}, 0x0000, 'S', "arrowright" },
    { {'\xe2', '\x86', '\x94', 0}, 0x0000, 'S', "arrowboth" },
    { {'\xe2', '\x86', '\x93', 0}, 0x0000, 'S', "arrowdown" },
    { {'\xe2', '\x86', '\x91', 0}, 0x0000, 'S', "arrowup" },
    { {'\xe2', '\x87', '\x90', 0}, 0x0000, 'S', "arrowdblleft" },
    { {'\xe2', '\x87', '\x92', 0}, 0x0000, 'S', "arrowdblright" },
    { {'\xe2', '\x87', '\x94', 0}, 0x0000, 'S', "arrowdblboth" },
    { {'\xe2', '\x87', '\x93', 0}, 0x0000, 'S', "arrowdbldown" },
    { {'\xe2', '\x87', '\x91', 0}, 0x0000, 'S', "arrowdblup" },
    { {'\xe2', '\x94', '\x80', 0}, 0x0000, 'S', "arrowhorizex" },

  // Lines
  //=======
// bar
    { {'\xe2', '\x94', '\x82', 0}, 0x0000, 'S', "arrowvertex" }, // tall bar, should be br or bv
// ru 
// ul
// bv - same code as br
    { {'\xc2', '\xa6', 0,      0}, 0x00A6, 0, "brokenbar" },
// slash
// backslash

  // Text markers
  //==============
    { {'\xe2', '\x97', '\xaf', 0}, 0x0000, 'E', "circle" },
    { {'\xc2', '\xb7', 0,      0}, 0x2022, 'S', "bullet" },
    { {'\xe2', '\x80', '\xa1', 0}, 0x2021, 0, "daggerdbl" },
    { {'\xe2', '\x80', '\xa0', 0}, 0x2020, 0, "dagger" },
    { {'\xe2', '\x97', '\x8a', 0}, 0x0000, 'S', "lozenge" },
    { {'\xe2', '\x96', '\xa1', 0}, 0x0000, 'E', "square" },
    { {'\xc2', '\xb6', 0,      0}, 0x00B6, 0, "paragraph" },
    { {'\xc2', '\xa7', 0,      0}, 0x00A7, 0, "section" },
    { {'\xe2', '\x98', '\x9c', 0}, 0x0000, 'E', "handleft" },
    { {'\xe2', '\x98', '\x9e', 0}, 0x0000, 'E', "handright" },
// at
//  numbersign
    { {'\xe2', '\x90', '\x8d', 0}, 0x0000, 'S', "carriagereturn" },
//  static char   a19[] = {'\xe2', '\x', '\x', 0};  // check mark, tick

  // Legalize
  //==========
    { {'\xc2', '\xa9', 0,      0}, 0x00A9, 0, "copyright" },        // a9
    { {'\xc2', '\xae', 0,      0}, 0x00AE, 0, "registered" },
    { {'\xe2', '\x84', '\xa2', 0}, 0x2122, 0, "trademark" },

  // Currency Symbols
  //==================
// dollar 
    { {'\xc2', '\xa2', 0,      0}, 0x00A2, 0, "cent" },
    { {'\xe2', '\x82', '\xac', 0}, 0x0000, 'S', "Euro" },
    { {'\xc2', '\xa5', 0,      0}, 0x00A5, 0, "yen" },
    { {'\xc2', '\xa3', 0,      0}, 0x00A3, 0, "sterling" },
    { {'\xc2', '\xa4', 0,      0}, 0x00A4, 0, "currency" },  // Scandinavian currency sign 
    { {'\xc6', '\x92', 0,      0}, 0x0192, 0, "florin" },

  // Units
  //=======
    { {'\xc2', '\xb0', 0,      0}, 0x00B0, 0, "degree" },
    { {'\xe2', '\x80', '\xb0', 0}, 0x2030, 0, "perthousand" },
    { {'\xe2', '\x80', '\xb2', 0}, 0x0000, 'S', "minute" },
    { {'\xe2', '\x80', '\xb3', 0}, 0x0000, 'S', "second" },
    { {'\xc2', '\xb5', 0,      0}, 0x03BC, 0, "mu" },         // micro sign
    { {'\xc2', '\xaa', 0,      0}, 0x00AA, 0, "ordfeminine" },
    { {'\xc2', '\xba', 0,      0}, 0x00BA, 0, "ordmasculine" },

  // Logical Symbols
  //=================
    { {'\xe2', '\x88', '\xa7', 0}, 0x0000, 'S', "logicaland" },
    { {'\xe2', '\x88', '\xa8', 0}, 0x0000, 'S', "logicalor" },
    { {'\xc2', '\xac', 0,      0}, 0x00AC, 'S', "logicalnot" },
    { {'\xe2', '\x88', '\x83', 0}, 0x0000, 'S', "existential" },
    { {'\xe2', '\x88', '\x80', 0}, 0x0000, 'S', "universal" },
    { {'\xe2', '\x88', '\x8b', 0}, 0x0000, 'S', "suchthat" },
    { {'\xe2', '\x88', '\xb4', 0}, 0x0000, 'S', "therefore" },

  // Maths Symbols
  //===============
    { {'\xc2', '\xbd', 0,      0}, 0x00BD, 0, "onehalf" },
    { {'\xc2', '\xbc', 0,      0}, 0x00BC, 0, "onequarter" },
    { {'\xc2', '\xbe', 0,      0}, 0x00BE, 0, "threequarters" },
    { {'\xc2', '\xb9', 0,      0}, 0x00B9, 0, "onesuperior" },
    { {'\xc2', '\xb2', 0,      0}, 0x00B2, 0, "twosuperior" },
    { {'\xc2', '\xb3', 0,      0}, 0x00B3, 0, "threesuperior" },
// plusmath
    { {'\xe2', '\x88', '\x92', 0}, 0x2212, 0, "minus" },
    { {'\xc2', '\xb1', 0,      0},  0x00B1, 0, "plusminus" },
// periodcentered - same code as bullet
    { {'\xe2', '\x8b', '\x85', 0}, 0x0000, 'S', "dotmath" },
    { {'\xc3', '\x97', 0,      0}, 0x00D7, 0, "multiply" },
    { {'\xe2', '\x8a', '\x97', 0}, 0x0000, 'S', "circlemultiply" },
    { {'\xe2', '\x8a', '\x95', 0}, 0x0000, 'S', "circleplus" },
    { {'\xc3', '\xb7', 0,      0}, 0x00F7, 0, "divide" },
    { {'\xe2', '\x81', '\x84', 0}, 0x2044, 0, "fraction" },
    { {'\xe2', '\x88', '\x97', 0}, 0x0000, 'S', "asteriskmath" },
    { {'\xe2', '\x89', '\xa4', 0}, 0x0000, 0, "lessequal" },
    { {'\xe2', '\x89', '\xa5', 0}, 0x0000, 0, "greaterequal" },
    { {'\xe2', '\x89', '\xa0', 0}, 0x0000, 0, "notequal" },
// equalmath
    { {'\xe2', '\x89', '\xa1', 0}, 0x0000, 'S', "equivalence" },  // identical
    { {'\xe2', '\x89', '\x85', 0}, 0x0000, 'S', "congruent" },
// similar
    { {'\xe2', '\x89', '\x88', 0}, 0x0000, 'S', "approxequal" },
    { {'\xe2', '\x88', '\x9d', 0}, 0x0000, 'S', "proportional" },
    { {'\xe2', '\x88', '\x85', 0}, 0x0000, 'S', "emptyset" },
    { {'\xe2', '\x88', '\x88', 0}, 0x0000, 'S', "element" },
    { {'\xe2', '\x88', '\x89', 0}, 0x0000, 'S', "notelement" },
    { {'\xe2', '\x8a', '\x84', 0}, 0x0000, 'S', "notsubset" },
    { {'\xe2', '\x8a', '\x82', 0}, 0x0000, 'S', "propersubset" },
    { {'\xe2', '\x8a', '\x83', 0}, 0x0000, 'S', "propersuperset" },
    { {'\xe2', '\x8a', '\x86', 0}, 0x0000, 'S', "reflexsubset" },
    { {'\xe2', '\x8a', '\x87', 0}, 0x0000, 'S', "reflexsuperset" },
    { {'\xe2', '\x88', '\xa9', 0}, 0x0000, 'S', "intersection" }, // also known as cap
    { {'\xe2', '\x88', '\xaa', 0}, 0x0000, 'S', "union" },        // also known as cup
    { {'\xe2', '\x88', '\xa0', 0}, 0x0000, 'S', "angle" },
    { {'\xe2', '\x8a', '\xa5', 0}, 0x0000, 'S', "perpendicular" },
    { {'\xe2', '\x88', '\xab', 0}, 0x0000, 'S', "integral" },
    { {'\xe2', '\x88', '\x91', 0}, 0x0000, 'S', "summation" },    // also known as sum
    { {'\xe2', '\x88', '\x8f', 0}, 0x0000, 'S', "product" },
    { {'\xe2', '\x88', '\x87', 0}, 0x0000, 'S', "gradient" },
    { {'\xe2', '\x88', '\x9a', 0}, 0x0000, 'S', "radical" },      // square root
    { {'\xe2', '\x80', '\xbe', 0}, 0x0000, 'S', "radicalex" },    // overline
    { {'\xe2', '\x88', '\x9e', 0}, 0x0000, 'S', "infinity" },
    { {'\xe2', '\x84', '\xb5', 0}, 0x0000, 'S', "aleph" },
    { {'\xe2', '\x84', '\x91', 0}, 0x0000, 'E', "Ifractur" },
    { {'\xe2', '\x84', '\x9c', 0}, 0x0000, 'E', "Rfractur" },
    { {'\xe2', '\x84', '\x98', 0}, 0x0000, 'S', "weierstrass" },
    { {'\xe2', '\x88', '\x82', 0}, 0x0000, 'S', "partialdiff" },
  // GREEK Characters
  //==================
    { {'\xce', '\x91', 0,      0}, 0x0000, 'S', "Alpha" },
    { {'\xce', '\x92', 0,      0}, 0x0000, 'S', "Beta" },
    { {'\xce', '\x9e', 0,      0}, 0x0000, 'S', "Xi" },
    { {'\xce', '\x94', 0,      0}, 0x0000, 'S', "Delta" },
    { {'\xce', '\x95', 0,      0}, 0x0000, 'S', "Epsilon" },
    { {'\xce', '\xa6', 0,      0}, 0x0000, 'S', "Phi" },
    { {'\xce', '\x93', 0,      0}, 0x0000, 'S', "Gamma" },
    { {'\xce', '\x98', 0,      0}, 0x0000, 'S', "Theta" },
    { {'\xce', '\x99', 0,      0}, 0x0000, 'S', "Iota" },
    { {'\xce', '\x9a', 0,      0}, 0x0000, 'S', "Kappa" },
    { {'\xce', '\x9b', 0,      0}, 0x0000, 'S', "Lambda" },
    { {'\xce', '\x9c', 0,      0}, 0x0000, 'S', "Mu" },
    { {'\xce', '\x9d', 0,      0}, 0x0000, 'S', "Nu" },
    { {'\xce', '\x9f', 0,      0}, 0x0000, 'S', "Omicron" },
    { {'\xce', '\xa0', 0,      0}, 0x0000, 'S', "Pi" },
    { {'\xce', '\xa8', 0,      0}, 0x0000, 'S', "Psi" },
    { {'\xce', '\xa1', 0,      0}, 0x0000, 'S', "Rho" },
    { {'\xce', '\xa3', 0,      0}, 0x0000, 'S', "Sigma" },
    { {'\xce', '\xa4', 0,      0}, 0x0000, 'S', "Tau" },
    { {'\xce', '\xa5', 0,      0}, 0x0000, 'S', "Upsilon" },
    { {'\xce', '\xa9', 0,      0}, 0x0000, 'S', "Omega" },
    { {'\xce', '\xa7', 0,      0}, 0x0000, 'S', "Chi" },
    { {'\xce', '\x97', 0,      0}, 0x0000, 'S', "Eta" },
    { {'\xce', '\x96', 0,      0}, 0x0000, 'S', "Zeta" },

    { {'\xce', '\xb1', 0,      0}, 0x0000, 'S', "alpha" },
    { {'\xce', '\xb2', 0,      0}, 0x0000, 'S', "beta" },
    { {'\xce', '\xbe', 0,      0}, 0x0000, 'S', "xi" },
    { {'\xce', '\xb4', 0,      0}, 0x0000, 'S', "delta" },
    { {'\xce', '\xb5', 0,      0}, 0x0000, 'S', "epsilon" },
    { {'\xcf', '\x86', 0,      0}, 0x0000, 'S', "phi" },
    { {'\xcf', '\x95', 0,      0}, 0x0000, 'S', "phi1" },
    { {'\xce', '\xb3', 0,      0}, 0x0000, 'S', "gamma" },
    { {'\xce', '\xb8', 0,      0}, 0x0000, 'S', "theta" },
    { {'\xcf', '\x91', 0,      0}, 0x0000, 'S', "theta1" },
    { {'\xce', '\xb9', 0,      0}, 0x0000, 'S', "iota" },
    { {'\xce', '\xba', 0,      0}, 0x0000, 'S', "kappa" },
    { {'\xce', '\xbb', 0,      0}, 0x0000, 'S', "lambda" },
    { {'\xce', '\xbc', 0,      0}, 0x0000, 'S', "mu" },
    { {'\xce', '\xbd', 0,      0}, 0x0000, 'S', "nu" },
    { {'\xce', '\xbf', 0,      0}, 0x0000, 'S', "omicron" },
    { {'\xcf', '\x80', 0,      0}, 0x0000, 'S', "pi" },
    { {'\xcf', '\x96', 0,      0}, 0x0000, 'S', "omega1" },
    { {'\xcf', '\x88', 0,      0}, 0x0000, 'S', "psi" },
    { {'\xcf', '\x81', 0,      0}, 0x0000, 'S', "rho" },
    { {'\xcf', '\x83', 0,      0}, 0x0000, 'S', "sigma" },
    { {'\xcf', '\x84', 0,      0}, 0x0000, 'S', "tau" },
    { {'\xcf', '\x85', 0,      0}, 0x0000, 'S', "upsilon" },
    { {'\xcf', '\x89', 0,      0}, 0x0000, 'S', "omega" },
    { {'\xcf', '\x87', 0,      0}, 0x0000, 'S', "chi" },
    { {'\xce', '\xb7', 0,      0}, 0x0000, 'S', "eta" },
    { {'\xce', '\xb6', 0,      0}, 0x0000, 'S', "zeta" },
    { {'\xcf', '\x82', 0,      0}, 0x0000, 'S', "sigma1" },

  // Playing Cards
  //===============
    { {'\xe2', '\x99', '\xa3', 0}, 0x0000, 'S', "club" },
    { {'\xe2', '\x99', '\xa0', 0}, 0x0000, 'S', "spade" },
    { {'\xe2', '\x99', '\xa5', 0}, 0x0000, 'S', "heart" },
    { {'\xe2', '\x99', '\xa6', 0}, 0x0000, 'S', "diamond" },


  // Miscellaneous - not in groff_char, could use execute for these
  // ===============================================================
  //  { {'\xe2', '\x8c', '\x88', 0}, 0, "" }, // Large square brackets, LEFT
  //  { {'\xe2', '\x8c', '\x89', 0}, 0, "" }, // Large square brackets, RIGHT
  //  { {'\xe2', '\x8c', '\x8a', 0}, 0, "" }, // Small square brackets, LEFT
  //  { {'\xe2', '\x8c', '\x8b', 0}, 0, "" }, // Small square brackets, RIGHT 

    { {0,      0,       0,     0}, 0x0000, 0, NULL } // TERMINAL MARKER

  };

/*********************************************************************
// These all print as themselves... omitted, also all alphanumeric characters and space
       Output   Input   Input   PostScript       Notes
                name    code    name

       !        !       33      exclam
       "        "       34      quotedbl
       #        #       35      numbersign
       $        $       36      dollar
       %        %       37      percent
       &        &       38      ampersand
       ’        '       39      quoteright
       (        (       40      parenleft
       )        )       41      parenright
       *        *       42      asterisk
       +        +       43      plus
       ,        ,       44      comma
       -        -       45      hyphen
       .        .       46      period
       /        /       47      slash
       :        :       58      colon
       ;        ;       59      semicolon
       <        <       60      less
       =        =       61      equal
       >        >       62      greater
       ?        ?       63      question
       @        @       64      at
       [        [       91      bracketleft
       \        \       92      backslash
       ]        ]       93      bracketright
       ^        ^       94      circumflex       circumflex accent
       _        _       95      underscore
       ‘         `      96      quoteleft
       {        {       123     braceleft
       |        |       124     bar
       }        }       125     braceright
       ~        ~       126     tilde            tilde accent
*********************************************************************/


// Return TRUE if a valid character
// Otherwise if cur_len>0 it wasn't in the table so display ? and advance past it
// the sequence
bool Printfile::do_get_char(void)
{
  cur_len = mbrlen(p, MB_CUR_MAX, NULL);

  if (cur_len > 0)
    {
      for (int n=0; n<cur_len; n++)
	cur_char[n] = *p++;
      cur_char[cur_len] = 0;

      if (cur_len > 1)
	{
	  // Get index into chartable charname
	  // It may be a good idea to have an index array combined
	  // with the line array - 2 dimensional maybe

	  c = 0xFF; // NOT an ascii character (7 bit)

	  for (int i=0; chartable[i].code; ++i)
	    {
	      if (STREQ(cur_char, chartable[i].code))
		{
		  cur_index = i;
		  return TRUE;
		}
	    }

	  // NOT IN THE TABLE!
	  printf("CHARACTER NOT IN TABLE\n");
	  cur_index = -1;
	  return FALSE;
	}

      // Ascii character, length 1
      cur_index = 0;
      c = cur_char[0];
      return TRUE;
    }
  else if (cur_len == 0)
    {
      // ? ERROR - I think it means EOF
      c = 0xFF; // NOT an ascii character (7 bit)
      printf("STRANGE ERROR - EOF?\n");
    }
  else
    {
      printf("INVALID CHARACTER\n");
      c = 0xFF; // NOT an ascii character (7 bit)
      cur_index = -1;
      p++;  // advance just one character...
      //}
    }
  return FALSE;
}

bool Printfile::get_char(void)
{
  while (!do_get_char() )
	{
	  show_error();
	  if (p>=end)
	    {
	      finish_print();
	      return FALSE;
	    }
	}
  return TRUE;
}

// CHANGE THIS!
bool Printfile::get_nextchar_after_p(void)
{
  char *ch = p+1;

  next_len = mbrlen(ch, MB_CUR_MAX, NULL);
  if (next_len > 0)
    {
      for (int n=0; n<next_len; n++)
	{
	  next_char[n] = *ch++;
	}
      next_char[next_len] = 0;
      return TRUE;
    }
  return(FALSE);
}






void Printfile::show_ligature(int i)
{
  show_string();  // If there is a string to show...


  // Fixed width font OK
  // If we use a variable width font this always gets put at the start of the line
  // NEEDS WORK!
  // For variable width it needs to be calculated as follows:
  //      Get the current position
  //      Place the ligature in this cell
  //   instead of calculating it from scratch...

  if (fixed)
    {
      printf("(%s) showfwl\n", chartable[i].charname);
      ofp << "(" << chartable[i].charname << ")" << " showfwl\n";
    }
  else
    {
      printf("(%s) showvwl\n", chartable[i].charname);
      ofp << "(" << chartable[i].charname << ")" << " showvwl\n";
    }
}

void Printfile::show_glyph(int i)
{
  show_string();  // If there is a string to show...


  if (fixed)      // Fixed width glyph
    {
      if (chartable[i].font) // A different font and not ligature
	{
	  printf("%c ", chartable[i].font);
	  printf("/%s showfwg ",chartable[i].charname);
	  printf("N\n");
	}
      else printf("/%s showfwg\n(",chartable[i].charname);


      if (chartable[i].font) // A different font and not ligature
	{
	  ofp << chartable[i].font << " ";
	  ofp << "/" << chartable[i].charname << " showfwg ";
	  ofp << "N\n";
	}
      else
	{
	  ofp << "/" << chartable[i].charname << " showfwg\n";
	}
    }
  else // Variable width glyph
    {
      // Check for fonts...
      if (chartable[i].font)
	{
	  printf("%c\n", chartable[i].font);
	  ofp << chartable[i].font << "\n";
	}

      printf("/%s glyphshow\n", chartable[i].charname);
      ofp << "/" <<  chartable[i].charname << " glyphshow\n";
      if (chartable[i].font)
	{
	  printf("N\n");
	  ofp << "N\n";
	}

    }

}

void Printfile::show_string(void)
{


  if ((offset == 0) && (!fixed))
    {
      // This is measured in points (1 pt is 1/72 inch)
      printf("%%%% row= %d : rowsize= %d\n", row, rowsize);
      printf("%d %d moveto\n", l_margin, top_row - ((row) * rowsize) );

      ofp << "%%%% row= " << row << " : rowsize= " << rowsize << endl;
      ofp << l_margin << " " << top_row - ((row) * rowsize) << " moveto\n";
    }

  line[col] = 0;
  if (line[offset] == 0) return; // NO STRING!

  // B = size_y - b_margin is the last possible row
  // T = size_y - t_margin is first possible row
  // The number of rows is T - B / rowsize

  printf("(");
  ofp << "(";

  for (int i=offset; line[i]; i++)
    {
      // string control charcters
      if (line[i] == '(' || line[i] == ')' || line[i] == '\\')
	{
	  printf("\\%c", line[i]);
	  ofp << "\\" << line[i];
	}
      else
	{
	  printf("%c", (int) line[i]);
	  ofp << line[i];
	}
    }

  if (fixed)
    {
      printf(") showfws\n");
      ofp << ") showfws\n";
    }
  else
    {
      printf(") show\n");
      ofp << ") show\n";
    }
  offset = col;
}


void Printfile::show_error()
{
  show_string();

  offset = col;
  line[col++] = '?';
 
  // Output a violet question mark
  printf("ERC show_string NC\n"); 
  ofp << "ERC show_string NC\n";

  offset = col;
}



double Printfile::get_red(int colour)
{
  return( ( (double)((colour & 0x00FF0000) >> 16) ) / 255.0 );
}

double Printfile::get_green(int colour)
{
  return( ( (double)((colour & 0x0000FF00) >> 8) ) / 255.0 );
}

double Printfile::get_blue(int colour)
{
  return( ( (double)( (colour & 0x000000FF)) ) / 255.0 );
}

// Convert the man page buffer to a postscript file
void Printfile::create_postscript_file(void)
{
  TFile tf;
  string *tfname;

  string pathname = "/tmp/";
  pathname += (getpwuid( getuid() ))->pw_name;
  pathname += "_gmanpage_";
  pathname += mp->mpagename;

  string suffix = ".ps";

  int page = 1;
  offset = row = col = 0;


  /***************************************************************************
    printf("# UCS characters supported by utf2ps\n");
    for (int i = 0; i < (int) (sizeof(chartab)/sizeof(struct charentry)); i++)
      printf("0x%04x = %s\n", chartab[i].ucs,  chartab[i].s);
    return;
  ***************************************************************************/

  if ( !(tfname = tf.tfile(&pathname, &ofp, 3, &suffix)) )
    {
      tname = "";
      return;  // Can't open temporary file
    }

  tname = *tfname;

  //  cout << "\npathname is: " << pathname << endl;
  //  cout << "\ntname is   : " << *tname << endl << endl;


  printf("%%!PS-Adobe-3.0\n");
  ofp << "%!PS-Adobe-3.0\n";

  printf("%%%%EndComments\n");
  ofp << "%%EndComments\n";

  printf("%%%%BeginSetup\n");
  ofp << "%%BeginSetup\n";


  // the constants used in the generated program
  ofp << "/fontsize " << fontsize << " def\n";
  ofp << "/lm " << l_margin << " def\n";
  ofp << "/rm " << r_margin << " def\n";
  ofp << "/tm " << t_margin << " def\n";
  ofp << "/bm " << b_margin << " def\n";
  ofp << "/rowsperpage " << rows_per_page << " def\n";
  ofp << "/rowsize " << rowsize << " def\n";
  ofp << "/toprow " << top_row << " def\n";

  // how much an accent has to be lifted over capital character
  printf("/caplift fontsize fontsize 1 add div def\n");
  ofp << "/caplift fontsize fontsize 1 add div def\n";



  printf("/FSDS { findfont fontsize scalefont setfont } bind def\n");
  ofp << "/FSDS { findfont fontsize scalefont setfont } bind def\n";


  printf("/N { /%s FSDS NC } def\n", n_fontname.c_str());
  ofp << "/N { /" << n_fontname << " FSDS NC } def\n";


  printf("/I { /%s FSDS IC } def\n", i_fontname.c_str());
  ofp << "/I { /" << i_fontname << " FSDS IC } def\n";

  printf("/B { /%s FSDS BC } def\n", b_fontname.c_str());
  ofp << "/B { /" << b_fontname << " FSDS BC } def\n";

  printf("/S { /Symbol FSDS } def\n");
  ofp << "/S { /Symbol FSDS } def\n";




  /* cp = combining pair: two strings on stack, print second over
   * the first one, no vertical shift */
  printf("/cp { 1 index show\n"
         "      currentpoint\n"
         "      3 index stringwidth pop\n"
         "      -2 div 0 rmoveto\n"
         "      2 index stringwidth pop\n"
         "      -2 div 0 rmoveto\n"
         "      2 index show\n"
         "      moveto pop pop } def\n");
  ofp << "/cp { 1 index show\n"
         "      currentpoint\n"
         "      3 index stringwidth pop\n"
         "      -2 div 0 rmoveto\n"
         "      2 index stringwidth pop\n"
         "      -2 div 0 rmoveto\n"
         "      2 index show\n"
         "      moveto pop pop } def\n";


  /* scp = shifted combining pair: two strings plus x y offset
   * (multiple of font size) on stack, print shifted by offset over
   * the first one */
  printf("/scp { 3 index show\n"
         "      currentpoint\n"
         "      5 index stringwidth pop\n"
         "      -2 div 0 rmoveto\n"
         "      4 index stringwidth pop\n"
         "      -2 div 0 rmoveto\n"
	 "      3 index fontsize mul 3 index fontsize mul rmoveto\n"
         "      4 index show\n"
         "      moveto pop pop pop pop} def\n");
  ofp << "/scp { 3 index show\n"
         "      currentpoint\n"
         "      5 index stringwidth pop\n"
         "      -2 div 0 rmoveto\n"
         "      4 index stringwidth pop\n"
         "      -2 div 0 rmoveto\n"
	 "      3 index fontsize mul 3 index fontsize mul rmoveto\n"
         "      4 index show\n"
         "      moveto pop pop pop pop} def\n";


  /* Cp = capital combining pair: two strings on stack, print second over
   * the first one, vertical shift for tall and capital letters */
  printf("/Cp { 1 index show\n"
         "      currentpoint\n"
         "      3 index stringwidth pop\n"
         "      -2 div caplift rmoveto\n"
         "      2 index stringwidth pop\n"
         "      -2 div caplift rmoveto\n"
         "      2 index show\n"
         "      moveto pop pop } def\n");
  ofp << "/Cp { 1 index show\n"
         "      currentpoint\n"
         "      3 index stringwidth pop\n"
         "      -2 div caplift rmoveto\n"
         "      2 index stringwidth pop\n"
         "      -2 div caplift rmoveto\n"
         "      2 index show\n"
         "      moveto pop pop } def\n";


  /* rev = reverse (mirror along vertical axis) a string */
  printf("/rev { dup stringwidth rmoveto\n"
	 "       gsave currentpoint translate -1 1 scale\n"
	 "       show grestore } def\n");
  ofp << "/rev { dup stringwidth rmoveto\n"
	 "       gsave currentpoint translate -1 1 scale\n"
         "       show grestore } def\n";


  /* bgr = block graphic glyph (unit cube coordinates) */
  printf("/bgr { gsave currentpoint translate\n"
	 "       (M) stringwidth pop dup scale 0 -0.5 translate\n"
	 "       exec grestore (M) stringwidth rmoveto } def\n");
  ofp << "/bgr { gsave currentpoint translate\n"
	 "       (M) stringwidth pop dup scale 0 -0.5 translate\n"
         "       exec grestore (M) stringwidth rmoveto } def\n";

  // Get the width of the fixed width using "M"
  // Assume size of 1000 x 1000 containing a bounding box of 750 x 750
  // This allows almost no spacing for bold capitals

  if (n_fontname == "Courier")
    {
      ofp << "/cellwidth { (M) stringwidth pop } def\n";
    }
  else ofp << "/cellwidth { (M) stringwidth pop 49 mul 64 div} def\n";

  ofp << "/cellheight { (M) stringwidth exch pop } def\n";


  // general purpose string
  ofp << "/str 500 string def\n";

  // a single character as a string
  ofp << "/ch 1 string def\n";


  // Expects dict key  and value to be added multiplied or divided on the stack
  ofp << "/vadd { 3 copy pop get add put } def\n"; 
  ofp << "/vsub { 3 copy pop get sub put } def\n"; 
  ofp << "/vmul { 3 copy pop get mul put } def\n";
  ofp << "/vdiv { 3 copy pop get div put } def\n";


  // the variables used in the generated postscript file
  ofp << "/vars 15 dict def\n";

  ofp << "vars /row 0 put\n";    // row number in this page
  ofp << "vars /page 0 put\n";   // page number
  ofp << "vars /offset 0 put\n"; // offset into current line
  ofp << "vars /slen 0 put\n";   // length of string
  ofp << "vars /i 0 put\n";      // index of string
  ofp << "vars /col 0 put\n";    // column in this row being processed
  ofp << "vars /w 0 put\n";      // width of the glyph being measured
  ofp << "vars /os 0 put\n";     // offset into this cell to character/glyph
  ofp << "vars /x 0 put\n";      // x position for ligature
  ofp << "vars /y 0 put\n";      // y position for ligature



  // Get the offset to the character (in this cell)
  ofp << "/OS { ch stringwidth pop vars /cw get sub -2 div } def\n";

  // Get the offset for each ligature character in this cell
  // Assumes the width of the chars!
  //  ofp << "/LOS { vars /cw get vars /slen get 2 add div } def\n";
  //  ofp << "/LOS { vars /cw get vars /slen get div } def\n";    // better except for ff
  if (n_fontname == "Courier")
  {
  ofp << "/LOS { vars /cw get 4 div } def\n";
  }
  else 

  ofp << "/LOS { vars /cw get 3 div } def\n";

  // Ligature start offset (0 if 3 chars or LOS/2 if 2 chars) 
  ofp << "/LSO { 3 vars /slen get sub LOS mul 2 div } def\n";

  // Calculate the offset for a glyph and put into /os
  ofp << "/GOS { vars /w get vars /cw get sub -2 div } def\n";

  // Get basic X position
  ofp << "/BX { vars /col get vars /cw get mul lm add } def\n";

  // Get the X position to moveto for a character
  ofp << "/XP { BX OS add } def\n";

  // Get the Y position to moveto for a character or glyph
  ofp << "/YP { toprow vars /row get rowsize mul sub }  def\n";

  // Get the X position to moveto for a glyph
  ofp << "/XPG { BX GOS add } def\n";

  // XP on stack, calculate YP and moveto then show the character
  ofp << "/MS { XP YP moveto ch show } def\n";

  // There is a problem here after displaying a glyph
  // The glyph's should have been centred in its cell but it wasn't...
  ofp << "/showchar {\n";
  ofp << "str vars /i get get\n";             // Gets the char (as an int)
  ofp << "ch 0 3 -1 roll put\n";              // put the char into ch
  ofp << "MS\n";                              // show the character
  ofp << "vars /i 1 vadd vars /col 1 vadd\n"; // increment index and column of output
  ofp << " } def\n";

  // print a string in fixed width format
  // ------------------------------------
  ofp << "/showfws {\n";
  ofp << "str copy\n";                           // copy to str
  ofp << "length vars /slen 3 -1 roll put\n";    // length in slen
  ofp << "vars /i 0 put\n";                      // initialize index into string
  ofp << "vars /slen get { showchar } repeat\n"; // show each character in turn
  ofp << "} def\n";


  // Get a glyph's width
  ofp << "/glyphwidth {\n";
  ofp << "gsave\n";                  // This doesn't use the ordinary stack
  ofp << "nulldevice\n";
  ofp << "0 0 moveto\n";
  ofp << "glyphshow\n";
  ofp << "currentpoint pop\n";       // new x on stack
  ofp << "vars /w 3 -1 roll put\n";  // width
  ofp << "grestore\n";
  ofp << "} def\n";


  // Place a glyph correctly in its cell
  // The glyph name should be on the stack
  ofp << "/showfwg {\n";

  ofp << "dup\n";

  ofp << "glyphwidth\n";   // Should come back with width in vars /w

  // Try displaying the width - OK
  //  ofp << "(<) show\n";
  //  ofp << "vars /w get str cvs show\n";
  //  ofp << "(>) show\n";

  // Calulate the x and y positions and show the glyph
  ofp << "XPG YP moveto glyphshow\n";
  ofp << "vars /col 1 vadd\n";	      
  ofp << "} def\n";


  // FIXED WIDTH LIGATURE

  // Put the charactes into the same cell, spaced with vars /los
  ofp << "/showlchar {\n";
  ofp << "str vars /i get get\n";                // Gets the char (as an int)
  ofp << "ch 0 3 -1 roll put\n";                 // put the char into ch
  ofp << "LOS vars /i get mul LSO add BX add YP moveto ch show\n"; // show
  ofp << "vars /i 1 vadd\n";                     // increment index
  ofp << " } def\n";

  // print a string of characters in the one cell evenly spaced (ligature)
  // e.g fl is 2 chars so each char occupies 1/4 of the cell
  ofp << "/showfwl {\n";
  ofp << "str copy\n";                            // copy to str
  ofp << "length vars /slen 3 -1 roll put\n";     // length in slen
  ofp << "vars /i 0 put\n";                       // initialize index into string
  ofp << "vars /los LOS put\n";                   // get the ligature offset
  ofp << "vars /slen get { showlchar } repeat\n"; // show each character in turn
  ofp << "vars /col 1 vadd\n";
  ofp << "} def\n";



  // VARIBLE WIDTH LIGATURE

  ofp << "/showvwlchar {\n";
  ofp << "str vars /i get get\n";                // Gets the char (as an int)
  ofp << "ch 0 3 -1 roll put\n";                 // put the char into ch

  //  ofp << "vars /los get vars /i get mul LSO add vars /x get add vars /y get moveto ch show\n";
  ofp << "vars /los get vars /i get mul vars /x get add vars /y get moveto ch show\n";
  ofp << "vars /i 1 vadd\n";                     // increment index
  ofp << "} def\n";


  ofp << "/showvwl {\n";
  ofp << "str copy\n";                              // copy to str
  ofp << "length vars /slen 3 -1 roll put\n";       // length in slen
  ofp << "currentpoint\n";                          // get current position
  ofp << "vars /y 3 -1 roll put\n";                 // save y position
  ofp << "vars /x 3 -1 roll put\n";                 // save x position
  ofp << "vars /i 0 put\n";                         // initialize index into string
  ofp << "vars /los LOS put\n";                     // get the ligature offset
  ofp << "vars /slen get { showvwlchar } repeat\n"; // show each character in turn

  ofp << "vars /x get vars /cw get add vars /y get moveto\n"; // moveto 1 position forwards

  ofp << "} def\n";



  // Colours - each value from 0.0 to 1.0
  printf("/NC{%f %f %f setrgbcolor}bind def\n",
	 get_red(n_colour), get_green(n_colour), get_blue(n_colour));

  printf("/IC{%f %f %f setrgbcolor}bind def\n",
	 get_red(i_colour), get_green(i_colour), get_blue(i_colour));

  printf("/BC{%f %f %f setrgbcolor}bind def\n",
	 get_red(b_colour), get_green(b_colour), get_blue(b_colour));

  printf("/EBC{%f %f %f setrgbcolor}bind def\n",
	 get_red(eb_colour), get_green(eb_colour), get_blue(eb_colour));

  printf("/ERC{%f %f %f setrgbcolor}bind def\n",
	 get_red(er_colour), get_green(er_colour), get_blue(er_colour));


  ofp << "/NC{ " << get_red(n_colour)
      << " " << get_green(n_colour)
      << " " << get_blue(n_colour)
      << " setrgbcolor}bind def\n";

  ofp << "/IC{ " << get_red(i_colour)
      << " " << get_green(i_colour)
      << " " << get_blue(i_colour)
      << " setrgbcolor}bind def\n";

  ofp << "/BC{ " << get_red(b_colour)
      << " " << get_green(b_colour)
      << " " << get_blue(b_colour)
      << " setrgbcolor}bind def\n";

  ofp << "/EBC{ " << get_red(eb_colour)
      << " " << get_green(eb_colour)
      << " " << get_blue(eb_colour)
      << " setrgbcolor}bind def\n";

  ofp << "/ERC{ " << get_red(er_colour)
      << " " << get_green(er_colour)
      << " " << get_blue(er_colour)
      << " setrgbcolor}bind def\n";


  ofp <<

"8 dict begin"
"/FontType 3 def\n"
"/FontMatrix [.001 0 0 .001 0 0] def\n"
"/FontBBox [0 0 750 750] def\n"
"/Encoding 256 array def\n"
"0 1 255 {Encoding exch /.notdef put} for\n"
"Encoding 97 /square put      %% ASCII a = 97\n"
"Encoding 98 /triangle put    %% ASCII b = 98\n"
"Encoding 99 /circle put      %% ASCII c = 99\n"
"Encoding 100 /handleft put   %% ASCII d = 100\n"
"Encoding 101 /handright put  %% ASCII e = 101\n"
"Encoding 102 /Ifractur put   %% ASCII f = 102\n"
"Encoding 103 /Rfractur put   %% ASCII g = 103\n"

"/CharProcs 8 dict def\n"
"CharProcs begin\n"
"/.notdef { } def\n"
"/square\n"
"{250 250 moveto\n"
"40 setlinewidth\n"
"500 250 lineto\n"
"500 500 lineto\n"
"250 500 lineto\n"
" closepath\n"
"stroke\n"

//"newpath\n"
//"10 setlinewidth\n"
//"0 0 moveto\n"
//"0 750 lineto\n"
//"750 750 lineto\n"
//"750 0 lineto\n"
//"closepath\n"
//"stroke\n"

"} bind def\n"

"/triangle\n"
"{0 0 moveto\n"
"375 750 lineto\n"
"750 0 lineto\n"
"closepath\n"
"fill\n"
"} bind def\n"

"/circle\n"
"{500 325 moveto\n"
"375 375 105 0 360 arc\n"
"375 375 145 360 0 arcn\n"
"closepath\n"
"fill\n"
"} bind def\n"

"/handleft\n"
"{740 550 moveto\n"
"60 550 lineto\n"
"60 500 50 90 270 arc\n"
"340 450 lineto\n"
"340 400 50 90 270 arc\n"
"400 350 lineto\n"
"400 300 50 90 270 arc\n"
"460 250 lineto\n"
"460 200 50 90 270 arc\n"
"740 150 lineto\n"
"closepath\n"
"fill\n"
"} bind def\n"

"/handright\n"
"{10 550 moveto\n"
"690 550 lineto\n"
"690 500 50 90 270 arcn\n"
"410 450 lineto\n"
"410 400 50 90 270 arcn\n"
"350 350 lineto\n"
"350 300 50 90 270 arcn\n"
"290 250 lineto\n"
"290 200 50 90 270 arcn\n"
" 10 150 lineto\n"
"closepath\n"
"fill\n"
"} bind def\n"

"/Ifractur\n"
"{350 345 moveto\n"
"150 350 300 750 600 600 curveto\n"
"600 600 450 450 500 325 curveto\n"
"700 80 450 10 320 110 curveto\n"
"230 170 lineto\n"
"200 170 lineto\n"
"200 180 lineto\n"
"280 230 lineto\n"
"350 180 lineto\n"
"480 50 650 100 440 280 curveto\n"
"350 400 470 500 510 530 curveto\n"
"350 600 160 400 350 345 curveto\n"
"closepath\n"
"fill\n"
"} bind def\n"

"/Rfractur\n"
"{180 300 moveto\n"
"180 330 lineto\n"
"-100 700 550 850 280 70 curveto\n"
"170 120 lineto\n"
"140 90 lineto\n"
"130 90 lineto\n"
"160 180 lineto\n"
"250 130 lineto\n"
"400 800 -50 620 240 370 curveto\n"
"190 300 lineto\n"
"closepath\n"
"fill\n"
"newpath\n"
"300 550 moveto\n"
"450 620 lineto\n"
"600 500 lineto\n"
"310 350 lineto\n"
"310 380 lineto\n"
"500 480 lineto\n"
"400 570 lineto\n"
"300 520 lineto\n"
"closepath\n"
"fill\n"
"newpath\n"
"330 370 moveto\n"
"460 380 400 130 500 70 curveto\n"
"600 130 lineto\n"
"600 140 lineto\n"
"550 140 lineto\n"
"480 150 500 350 430 420 curveto\n"
"closepath\n"
"fill\n"
"} bind def\n"

"end\n"

"/BuildGlyph\n"
"{1000 0\n"
"0 0 750 750\n"
"setcachedevice\n"
"exch /CharProcs get exch\n"
"2 copy known not\n"
"{pop /.notdef}\n"
"if\n"
"get exec\n"
"} bind def\n"
"/BuildChar\n"
"{1 index /Encoding get exch get\n"
"1 index /BuildGlyph get exec\n"
"} bind def\n"
"currentdict\n"
"end\n";        // END OF FONT DICTIONARY


  ofp << "/ExtrasFont exch definefont pop\n";


  printf("/E { /ExtrasFont FSDS } def\n");
  ofp << "/E { /ExtrasFont FSDS } def\n";





  printf("%%%%EndSetup\n");
  ofp << "%%EndSetup\n";

  printf("%%%%Page: %d %d\n", page, page);
  ofp << "%%Page: " << page << " " << page << "\n";

  printf("N\n");
  ofp << "N\n";


  printf("vars /cw cellwidth put\n");
  ofp << "vars /cw cellwidth put\n";

  printf("vars /ch cellheight put\n");
  ofp << "vars /ch cellheight put\n";


  while (p<end)
    {
      if (!get_char() ) return;

      //      printf("DONE get_char() 1\n");

    /*************** CHECK FOR ITALIC **********************************/

    RE_CHECK:
    if ((c == '_') && ( (*p)== '\b' ) )              // CHECK FOR ITALIC
      {
	bool italic = FALSE;

	if (col) show_string();  // Up to here to be displayed
	offset = col;

	while ((c == '_') && ( (*p)== '\b' ) )
	  {
	    p++;                             // skip \b to get the char use
	    if (!get_char()) return;

	    if (!italic)
	      {
		printf("I ");
		ofp << "I ";
		italic = TRUE;
	      }

	    if ((c == '\xff') && (cur_index >= 0))  // If a glyph
	      {
		if (chartable[cur_index].font == 'L')
		  {
		    show_ligature(cur_index);
		  }
		else show_glyph(cur_index);
	      }
		
	    else if (col < 500)
	      {
		line[col++] = c;
	      }

	    if (!get_char()) return;
	  }


	// Now display the string 
	show_string();
	printf("N ");
	ofp << "N ";
	offset = col;
      }

    /******************** END OF ITALIC *********************/


    // CHECK FOR BOLD
    // The backspace is accessible here
    if ( ((*p) == '\b') && 
	 get_nextchar_after_p() && 
	 (cur_len == next_len) &&
	 STREQ(cur_char, next_char) ) 
      {
	if (col) show_string();  // Up to here to be displayed
	offset = col;
	bool eb = FALSE;
	bool bold = FALSE;

	for (;;)  // FOREVER
	  {

	    if ( ((*p) == '\b') &&             // If this character is BOLD
		 get_nextchar_after_p() && 
		 (cur_len == next_len) &&
		 STREQ(cur_char, next_char) ) 
	      {

		printf("GOT BOLD %c\n", c);

		// Now display the BOLD 
		if (!bold)
		  {
		    printf("B ");
		    ofp << "B ";
		    bold = TRUE;
		  }

		p += cur_len + 1;              // Point p to the next maybe backspace

		if ( ((*p) == '\b') &&         // If this character is EXTRA_BOLD
		     get_nextchar_after_p() && 
		     (cur_len == next_len) &&
		     STREQ(cur_char, next_char) )
		  {
		    printf("EBC ");
		    ofp << "EBC ";
		    eb = TRUE;
		  }

		                               // Show a glyph or store a char
		if ((c == '\xff') && (cur_index >= 0))  // If a glyph
		  {
		    if (chartable[cur_index].font == 'L')
		      {
			show_ligature(cur_index);
		      }
		    else show_glyph(cur_index);
		  }
		
		else if (col < 500)
		  {
		    line[col++] = c;
		  }
	      }

	    else break;  // QUIT FOREVER if not bold

	    while ( ((*p) == '\b') && 
		    get_nextchar_after_p() && 
		    (cur_len == next_len) &&
		    STREQ(cur_char, next_char) )
	      {
		p += cur_len + 1; // Point p to the next maybe backspace
	      }

	    if (!get_char()) return;

	  } // End of FOREVER

	show_string();

	if (eb) eb = FALSE;

	printf("N ");
	ofp << "N ";
	offset = col;


	goto RE_CHECK;  // NOTE: it could be italic now... Don't like it...
      }

    /*************************************************************/

    //    printf("DONE BOLD & ITALIC\n");


    // Somehow this doubles the rows
    // If fixed it makes no difference but otherwise the lines are double-spaced
    if ((c == '\x0a') && (cur_index == 0))
      {
	if (col > 0)
	  {
	    show_string();
	    offset = 0;
	    col = 0;
	    if (fixed)
	      {
		printf("vars /col 0 put\n");
		ofp << "vars /col 0 put\n";
	      }
	  }

	row++;
	if (row >= rows_per_page)
	  {
	    printf("showpage\n");
	    ofp << "showpage vars /row 0 put\n";

	    page++;
	    printf("%%%%Page: %d %d\n", page, page);
	    ofp << "%%Page: " << page << " " << page << "\n";
	    row = 0;
	  }
	else // What if we come to the end of the page?
	  {
	    int n = 0;

	    while (*p == 0x0a)
	      {
		n++;
		p++;
	      }
	    row += n;

	    // If this is beyond the end of the page, start a new one
	    if (row >= rows_per_page)
	      {
		printf("showpage\n");
		ofp << "showpage vars /row 0 put\n";

		page++;
		printf("%%%%Page: %d %d\n", page, page);
		ofp << "%%Page: " << page << " " << page << "\n";
		row = 0;
	      }
	  }

	if (fixed)
	  {
	    printf("vars /row %d  put\n", row);
	    ofp << "vars /row " << row  << " put\n";
	  }
      }

    else if ((c == '\xff') && (cur_index >= 0)) // a glyph
      {
	if (chartable[cur_index].font == 'L')
	  {
	    show_ligature(cur_index);
	  }
	else
	  {
	    show_glyph(cur_index);
	  }
	col++;
	line[col] = 0;
	offset = col;
      }

    else if (cur_index == 0) // normal ascii character
      {
	if (col < 500)
	  {
	    line[col++] = c;
	  }
      }

    }

  if (col)
    {
      show_string();
    }

  finish_print();
}

void Printfile::finish_print(void)
{
  printf("showpage\n");
  ofp << "showpage\n";


  printf("%%%%EOF\n");
  ofp << "%%EOF\n";

  if ( ofp.is_open() ) ofp.close();
  //  return 0;
}



void Printfile::do_printfile(bool preview)

{
  size_x = gman->prefs.papersize.width;
  size_y = gman->prefs.papersize.height;
  l_margin = gman->prefs.l_margin;
  r_margin = gman->prefs.r_margin;
  t_margin = gman->prefs.t_margin;
  b_margin = gman->prefs.b_margin;

/*  n_colour = gman->prefs.n_pcolour;
  i_colour = gman->prefs.i_pcolour;
  b_colour = gman->prefs.b_pcolour;
  eb_colour = gman->prefs.eb_pcolour;
  er_colour = gman->prefs.er_pcolour;
*/
  fontsize = gman->prefs.fontsize;
  rowsize = fontsize + 1; // + 2;
  n_fontname = gman->prefs.fontname;
  b_fontname = n_fontname + "-Bold";

  if (n_fontname == "Courier")  // Courier is already fixed width
    {                           // but glyphs may be a problem...
    fixed = FALSE;
    }
  else fixed = gman->prefs.fixed;

  if (n_fontname == "Times")
    {
    n_fontname = "Times-Roman";
    i_fontname = "Times-Italic";
    }
  else
    {
      i_fontname = n_fontname + "-Oblique";
    }



  rows_per_page = (size_y - t_margin - b_margin) / rowsize;

  // NBG
  // The Postscript file will have to work it out...
  //  columns_per_row = (papersize_x - l_margin - r_margin) / charwidth;

  top_row = size_y - t_margin - fontsize;

  create_postscript_file();


  if ( (!preview) && (tname.length()) ) 
    {
      string buffer = "lpr -P ";
	  
      buffer += gman->prefs.printername;
      buffer += " -r ";
      buffer += tname;
      buffer += " &";

//      printf("tname= \"%s\" : fontsize= %d : rowsize= %d : %s\n",
//	     tname.c_str(), fontsize, rowsize, gman->prefs.fontname.c_str());

//      cout << "Printfile::do_printfile - " << buffer << endl;
      
      system(buffer.c_str());
    }

  //  printf("Printfile::do_printfile: GOT %s\n", mp->mpagename);
}
