/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       printfile.h                                               *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       21-Mar-2009 12.00.34 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __PRINTFILE_H__
#define __PRINTFILE_H__

#include <iostream>
#include <fstream>
#include <wchar.h>
#include <stdlib.h>

#include "gman.h"
#include "manpage.h"

using namespace std;

class Printfile
{
 public:
  Printfile(ManPage *manpage);
  Printfile(ManPage *manpage, string &fname);
  ~Printfile(void);
  void do_printfile(void);

 private:
  double get_red(int colour);
  double get_green(int colour);
  double get_blue(int colour);

    bool get_nextchar_after_p(void);
    bool do_get_char(void);
    bool get_char(void);
    void show_ligature(int i);
    void show_glyph(int i);
    void show_string(void);
    void show_error(void);
    void finish_print(void);
    void create_postscript_file(void);
    void do_printfile(bool preview);

    ManPage *mp;
    GMan *gman;
    char *p;            // current position in file
    char *end;          // address of terminal zero

    char line[500];     // line prepared for output
    int offset;         // position in line for start of output

    char cur_char[64];  // the character pointed to before p
    char c;             // ascii value of cur_char or 0xFF if not ascii
    int cur_len;        // the length of cur_char
    int cur_index;      // index in array of this char or -1

    char next_char[64]; // the character pointed to after p
    int next_len;       // the length of next_char

    fstream ofp;
    string tname;

    bool fixed;
    int fontsize, rowsize;
    string n_fontname;
    string i_fontname;
    string b_fontname;
    int rows_per_page;
    //    int columns_per_row;
    int top_row;

    int size_x, size_y;
    int col, row;
    int l_margin, r_margin, t_margin, b_margin;
    int n_colour;
    int i_colour;
    int b_colour;
    int eb_colour;
    int er_colour;

 protected:

};










#endif // _PRINTFILE_H
