/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       printprefs.h                                              *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       15-Mar-2013 11.45.20 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __PRINTPREFS_H__
#define __PRINTPREFS_H__

#include <gtk/gtk.h>
#include "gman.h"

class Printprefs
{
 public:
  Printprefs(class GMan *gm);
  ~Printprefs();

	static class GMan *gman;

 private:		
  static void close_dialog (GtkWidget *widget, Printprefs *pp);
  static void quit_printprefs(GtkWidget *widget, Printprefs *pp);
  static void callback_toggle_mutex(GtkWidget *widget, Printprefs *pp);
  static void do_save(GtkWidget *widget, Printprefs *pp);
  static void do_use(GtkWidget *widget, Printprefs *pp);
  static gint repaint(gpointer data);
		
  static void callback_general_defaults(GtkWidget *widget, Printprefs *pp);
  static void callback_default_text_colours(GtkWidget *widget, Printprefs *pp);
  static void callback_colour_r(GtkWidget *widget, Printprefs *pp);
  static void callback_colour_g(GtkWidget *widget, Printprefs *pp);
  static void callback_colour_b(GtkWidget *widget, Printprefs *pp);
  void paint_da(GtkWidget *da, double red, double green, double blue, Printprefs *pp);
  void create_display(char *title);
  GtkWidget *get_printers(void);

		
//  static GdkRGBA red;    // These are for a mutex style
//  static GdkRGBA black;
//  static GdkRGBA white;

  GtkWidget *fontsize_spinner;
  GtkWidget *fw_checkbutton;
  GtkWidget *left_margin_spinner;
  GtkWidget *right_margin_spinner;
  GtkWidget *top_margin_spinner;
  GtkWidget *bottom_margin_spinner;
  GtkWidget *pv_entry;

  GtkWidget *red_hspinner;
  GtkWidget *green_hspinner;
  GtkWidget *blue_hspinner;


	GdkRGBA *tog_fg;	
	GdkRGBA *tog_bg;

  GtkWidget *normal_tog;
  GtkWidget *italic_tog;
  GtkWidget *bold_tog;
  GtkWidget *ebold_tog;
  GtkWidget *err_tog;



  GtkWidget *da_normal;
  GtkWidget *da_italic;
  GtkWidget *da_bold;
  GtkWidget *da_ebold;
  GtkWidget *da_err;


  GtkWidget *da_current;


  double *r, *g, *b;      // current rgb
  double nr, ng, nb;
  double ir, ig, ib;
  double br, bg, bb;
  double ebr, ebg, ebb;
  double err, erg, erb;

  int timer;
  GdkPixbuf *pixbuf;
		
  GList *printer_list;
  GList *paper_size_list;
  GList *font_list;
		
  GtkWidget *window;
  GtkWidget *printers_combo;
  GtkWidget *paper_sizes_combo;
  GtkWidget *font_combo;

 protected:

};



#endif // _PRINTPREFS_H

