/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       quit.cpp                                                  *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       21-Mar-2009 12.03.14 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Various quit routines                                                     *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#include <gtk/gtk.h>
#include "quit.h"

int Quit::rc=0;

// constructor
Quit::Quit(void)
{

  // Fix Ctrl_C trap
  if (signal(SIGINT, CtrlCFunction)  == SIG_ERR)
    {
      rc = process_error(E_NO_CTRL_C);
    }
}

// destructor
Quit::~Quit(void)
{
  cout << "~Quit:\n";
}


int Quit::process_error(error errnum)
{
  static const char *ERROR_TXT[NUM_ERRORS] =
    {
      "User QUIT",
      "ERROR: No manpath found",
      "ERROR: X not loaded",
      "ERROR: Can't open main window",
      "ERROR: Can't set CTRL-C trap",
      "\n<< USER ABORT >>\n",
      "UNKNOWN ERROR"
    };

  if ((errnum < E_QUIT) || (errnum >= E_NOT_KNOWN))
    errnum = E_NOT_KNOWN;

  if (errnum)
    cerr << "ERROR " <<  errnum << ": " << ERROR_TXT[errnum] << "\n";
  else cerr << ERROR_TXT[errnum] << "\n";

  rc = (errnum > E_QUIT ) ? EXIT_FAILURE : EXIT_SUCCESS;
  return( rc ) ;
}

int Quit::get_rc(void)
{
  return(rc);
}

void Quit::CtrlCFunction(int n)
{
  process_error(E_USER_ABORT);
  gtk_main_quit();
}
