/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       search.h                                                  *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       29-Mar-2013 10.02.23 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __SEARCH_H__
#define __SEARCH_H__

#include <gtk/gtk.h>
#include <string>

#include "edit.h"
#include "misc.h"
#include "manpage.h"

using namespace std;

class Search
{
 public:
  Search(class ManPage *m);
  Search(gboolean replace, class Edit *e);
  ~Search(void);

  static void callback_next(GtkWidget *widget, Search *s);
  static void close_search(GtkWidget *widget, Search *s);

  GtkWidget *window;

 private:
  static void callback_replace(GtkWidget *widget, Search *s);
  static void callback_forwards_reverse(GtkWidget *widget, Search *s);
		
	static void start_timer(Search *s);  // while searching
	static void stop_timer(Search *s);
	static gboolean callback_searching(gpointer data);

  void display(gboolean replace);

  GdkPixbuf *pixbuf;
  GtkWidget *search_entry;
  GtkWidget *replace_entry;
  GtkWidget *forwards;
  GtkWidget *reverse;
  GtkWidget *match_case;
  GtkWidget *status;
	GtkWidget *working_label;
  GtkWidget *replace_label;
  GtkWidget *yes_button;
  string replace_string;
  string search_string;
  Edit *edit;
  class ManPage *manpage;
  GtkWidget *text;   // TextView
  gchar *ttext;      // The text that is in the buffer
  gint p;            // Starting = 0, forwards = 1, backwards = -1
        
  gint num_chars;
  gint char_index;
  gint old_char_index;
  gint char_inc;
  GtkTextBuffer *tbuf;
	guint timer_id;

	bool searching;

 protected:

};

#endif // _SEARCH_H
