/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       tfile.h                                                   *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       21-Mar-2009 12.05.26 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __TFILE_H__
#define __TFILE_H__

#include <iostream>
#include <fstream>


using namespace std;

class TFile
{
public:
  TFile(void);
  ~TFile(void);

  string convert_i2str(int i, int pad);
  string convert_i2str(int i);
  int power(int n, int base);

  string *tname(string *pathname, int n, string *suffix);
  string *tname(string *pathname, int n);

	string *tfile(string *pathname, fstream *ofp, int n, string *suffix);
  string *tfile(string *pathname, fstream *ofp, int n);
  string *tfile(string *pathname, fstream *ofp);

  int filecopy(string *dname, string *sname);
  int overwritefile(string *dname, string *sname);
                
  string *copy(string *pathname, int n);
  string *copy(string *pathname);
  int do_copy(fstream *ofp, fstream *ifp);
        
private:        
  int filecopy(string *dname, string *sname, int overwite);        
        
protected:
 
};
 
#endif // _TFILE_H
