/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    gmanpage                                                  *
*Project Version: 1.2.3                                                     *
*Copyright Owner: David M. Balean <linprogs@exemail.com.au>                 *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* iunder the terms of the GNU General Public License as published by        *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Saturday 27th April 2013                                  *
*                                                                           *
*Start DateStamp: 21-Mar-2009 12.12.52 -36000 3600                          *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
*                                                                           *
*Project Summary:                                                           *
* View manual pages and optionally create/edit them                         *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       windowsizes.h                                             *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       21-Mar-2009 12.06.05 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header                                                                    *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __WINDOWSIZES_H__
#define __WINDOWSIZES_H__

#include <gtk/gtk.h>

#include "gman.h"

class Windowsizes
{
 public:
  Windowsizes(class GMan *g);
  ~Windowsizes(void);

  static void close_dialog (GtkWidget *widget, Windowsizes *ws);
  static void quit_displayprefs(GtkWidget *widget, Windowsizes *ws);

  GMan *gman;
  GtkWidget *window;
 
 private:
  static void do_save(GtkWidget *widget, Windowsizes *ws);
  static void do_use(GtkWidget *widget, Windowsizes *ws);
  static void default_main_window_size(GtkWidget *widget, Windowsizes *ws);
  static void default_manpage_size(GtkWidget *widget, Windowsizes *ws);
  static void default_mandir_size(GtkWidget *widget, Windowsizes *ws);
  static void default_edit_size(GtkWidget *widget, Windowsizes *ws);
  static void default_apropos_size(GtkWidget *widget, Windowsizes *ws);
  static void default_printprefs_size(GtkWidget *widget, Windowsizes *ws);
  static void default_displayprefs_size(GtkWidget *widget, Windowsizes *ws);
  static void default_ediprefs_size(GtkWidget *widget, Windowsizes *ws);
  static void default_about_size(GtkWidget *widget, Windowsizes *ws);
  void get_user_data(Windowsizes *ws);
  void create_display(void);
  
  GtkWidget *main_window_width_spinner;
  GtkWidget *main_window_height_spinner;
  GtkWidget *manpage_width_spinner;
  GtkWidget *manpage_height_spinner;
  GtkWidget *mandir_width_spinner;
  GtkWidget *mandir_height_spinner;
  GtkWidget *edit_width_spinner;
  GtkWidget *edit_height_spinner;
  GtkWidget *apropos_width_spinner;
  GtkWidget *apropos_height_spinner;
  GtkWidget *printprefs_width_spinner;
  GtkWidget *printprefs_height_spinner;
  GtkWidget *displayprefs_width_spinner;
  GtkWidget *displayprefs_height_spinner;
  GtkWidget *editprefs_width_spinner;
  GtkWidget *editprefs_height_spinner;
  GtkWidget *about_height_spinner;
  GtkWidget *about_width_spinner;

  GdkPixbuf *pixbuf;

 protected:

};


#endif // _WINDOWSIZES_H
